#setwd('G:/Dropbox/Motif Analysis/Motif Analysis R Files/')
motifDir <- 'G:/Dropbox/Motif Analysis/Motif Analysis R Files/'
utilDir <- 'G:/Dropbox/RCode/'

source(paste(utilDir,'Utils.r',sep=''))
source(paste(motifDir,'MotifOutlierAnalysisFunctions.r',sep=''))

motifDirectory <- "C:/Documents and Settings/gillette/My Documents/research/MotifAnalysis/PercentileRanks/";
metaData <- read.csv(paste(directory,"arborMetaData-Map2.csv",sep=""))
rownames(metaData)<-metaData$Sequence
k <- 0
kPlus <- k+1
defaultOrder <- "STL"
defaultMethod <- 8
defaultThreshold <- 0
defaultThreshType <- "Whole"


# Read in percentile ranks for each sequence for a given k
outlierData3 <- getOutliers(3,order="LTS",method=3)

# Method 3 LTS, old storage
outlierData1B3_20 <- getOutliers(1,sets=20,order="LTS",method=3,threshold="0.0",directory=motifDirectory,thresholdTypeString="AbsStr")
outlierData2B3_20 <- getOutliers(2,sets=20,order="LTS",method=3,threshold="0.0",directory=motifDirectory,thresholdTypeString="AbsStr")
outlierData3B3_20 <- getOutliers(3,sets=20,order="LTS",method=3,threshold="0.0",directory=motifDirectory,thresholdTypeString="AbsStr")

outlierData1B3_40 <- getOutliers(1,sets=40,order="LTS",method=3,threshold="0.0",directory=motifDirectory,thresholdTypeString="AbsStr")
outlierData2B3_40 <- getOutliers(2,sets=40,order="LTS",method=3,threshold="0.0",directory=motifDirectory,thresholdTypeString="AbsStr")
outlierData3B3_40 <- getOutliers(3,sets=40,order="LTS",method=3,threshold="0.0",directory=motifDirectory,thresholdTypeString="AbsStr")

outlierRandData1B3_20 <- getOutliers(1,sets=20,order="LTS",method=3,threshold="0.0",directory=motifDirectory,thresholdTypeString="AbsStr",useRandomSet=41,useRandomK=0)
outlierRandData2B3_20 <- getOutliers(2,sets=20,order="LTS",method=3,threshold="0.0",directory=motifDirectory,thresholdTypeString="AbsStr",useRandomSet=41,useRandomK=1)
outlierRandData3B3_20 <- getOutliers(3,sets=20,order="LTS",method=3,threshold="0.0",directory=motifDirectory,thresholdTypeString="AbsStr",useRandomSet=41,useRandomK=2)

outlierRandData1B3_40 <- getOutliers(1,sets=40,order="LTS",method=3,threshold="0.0",directory=motifDirectory,thresholdTypeString="AbsStr",useRandomSet=41,useRandomK=0)
outlierRandData2B3_40 <- getOutliers(2,sets=40,order="LTS",method=3,threshold="0.0",directory=motifDirectory,thresholdTypeString="AbsStr",useRandomSet=41,useRandomK=1)
outlierRandData3B3_40 <- getOutliers(3,sets=40,order="LTS",method=3,threshold="0.0",directory=motifDirectory,thresholdTypeString="AbsStr",useRandomSet=41,useRandomK=2)

outlierData2B3T05_20 <- getOutliers(2,sets=20,order="LTS",method=3,threshold="0.05",directory=motifDirectory)
outlierData3B3T05_20 <- getOutliers(3,sets=20,order="LTS",method=3,threshold="0.05",directory=motifDirectory)

# Method 8
outlierData1_20 <- getOutliers(1,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData2_20 <- getOutliers(2,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData3_20 <- getOutliers(3,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData4_20 <- getOutliers(4,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData5_20 <- getOutliers(5,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)

outlierData1_40 <- getOutliers(1,sets=40,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData2_40 <- getOutliers(2,sets=40,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData3_40 <- getOutliers(3,sets=40,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData4_40 <- getOutliers(4,sets=40,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData5_40 <- getOutliers(5,sets=40,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)

outlierData1_60 <- getOutliers(1,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData2_60 <- getOutliers(2,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData3_60 <- getOutliers(3,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData4_60 <- getOutliers(4,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData5_60 <- getOutliers(5,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)

outlierData1_500 <- getOutliers(1,sets=500,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData2_500 <- getOutliers(2,sets=500,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData3_500 <- getOutliers(3,sets=500,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData4_500 <- getOutliers(4,sets=500,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData5_500 <- getOutliers(5,sets=500,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)

# Use percentile rank data to determine outliers (Method 8)
outlierData <- list()
outlierData[[1]] <- prDataB8_40[[1]] < .025 | prDataB8_40[[1]] > .975
outlierData[[2]] <- prDataB8_40[[2]] < .025 | prDataB8_40[[2]] > .975
outlierData[[3]] <- prDataB8_40[[3]] < .025 | prDataB8_40[[3]] > .975
outlierData[[4]] <- prDataB8_40[[4]] < .025 | prDataB8_40[[4]] > .975

outlierRandData <- list()
outlierRandData[[1]] <- prRandDataB8_40[[1]] < .025 | prRandDataB8_40[[1]] > .975
outlierRandData[[2]] <- prRandDataB8_40[[2]] < .025 | prRandDataB8_40[[2]] > .975
outlierRandData[[3]] <- prRandDataB8_40[[3]] < .025 | prRandDataB8_40[[3]] > .975
outlierRandData[[4]] <- prRandDataB8_40[[4]] < .025 | prRandDataB8_40[[4]] > .975

plotKmerRemainingOFMeans(outlierData,outlierRandData,1:4)
                         
outlierData1STL <- getOutliers(1,order="STL",method=8,threshold="0.0",directory=motifDirectory)
outlierData2B8STL <- getOutliers(2,order="STL",method=8,threshold="0.0",directory=motifDirectory)
outlierData3B8STL <- getOutliers(3,order="STL",method=8,threshold="0.0",directory=motifDirectory)
outlierData4B8STL <- getOutliers(4,order="STL",method=8,threshold="0.0",directory=motifDirectory)
outlierData5B8STL <- getOutliers(5,order="STL",method=8,threshold="0.0",directory=motifDirectory)

# Use randoms in place of reals for comparison; Method8 LTS NewStorage
outlierRandData1_20 <- getOutliers(1,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=0)
outlierRandData2_20 <- getOutliers(2,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=1)
outlierRandData3_20 <- getOutliers(3,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=2)
outlierRandData4_20 <- getOutliers(4,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=3)
outlierRandData5_20 <- getOutliers(5,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=4)

outlierRandData1_40 <- getOutliers(1,sets=40,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=0)
outlierRandData2_40 <- getOutliers(2,sets=40,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=1)
outlierRandData3_40 <- getOutliers(3,sets=40,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=2)
outlierRandData4_40 <- getOutliers(4,sets=40,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=3)
outlierRandData5_40 <- getOutliers(5,sets=40,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=4)

outlierRandData1_60 <- getOutliers(1,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=0)
outlierRandData2_60 <- getOutliers(2,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=1)
outlierRandData3_60 <- getOutliers(3,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=2)
outlierRandData4_60 <- getOutliers(4,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=3)
outlierRandData5_60 <- getOutliers(5,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=4)

outlierRandData1_500 <- getOutliers(1,sets=500,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=0)
outlierRandData2_500 <- getOutliers(2,sets=500,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=1)
outlierRandData3_500 <- getOutliers(3,sets=500,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=2)
outlierRandData4_500 <- getOutliers(4,sets=500,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=3)
outlierRandData5_500 <- getOutliers(5,sets=500,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=4)

mean(outlierData1_20$OutlierFraction)
1-mean(outlierData1_20$OutlierFraction)

meanOF <- function(mydf){
  mean(mydf$OutlierFraction)
}

pure20<-c(meanOF(outlierData1_20),meanOF(outlierData2_20),meanOF(outlierData3_20),meanOF(outlierData4_20),meanOF(outlierData5_20))
rand20<-c(meanOF(outlierRandData1_20),meanOF(outlierRandData2_20),meanOF(outlierRandData3_20),meanOF(outlierRandData4_20),meanOF(outlierRandData5_20))
pure40<-c(meanOF(outlierData1_40),meanOF(outlierData2_40),meanOF(outlierData3_40),meanOF(outlierData4_40),meanOF(outlierData5_40))
rand40<-c(meanOF(outlierRandData1_40),meanOF(outlierRandData2_40),meanOF(outlierRandData3_40),meanOF(outlierRandData4_40),meanOF(outlierRandData5_40))
pure60<-c(meanOF(outlierData1_60),meanOF(outlierData2_60),meanOF(outlierData3_60),meanOF(outlierData4_60),meanOF(outlierData5_60))
rand60<-c(meanOF(outlierRandData1_60),meanOF(outlierRandData2_60),meanOF(outlierRandData3_60),meanOF(outlierRandData4_60),meanOF(outlierRandData5_60))
pure500<-c(meanOF(outlierData1_500),meanOF(outlierData2_500),meanOF(outlierData3_500),meanOF(outlierData4_500),meanOF(outlierData5_500))
rand500<-c(meanOF(outlierRandData1_500),meanOF(outlierRandData2_500),meanOF(outlierRandData3_500),meanOF(outlierRandData4_500),meanOF(outlierRandData5_500))

outlierFractionsDF<-data.frame("20 surrogates"=pure20,"Error(20)"=rand20,"40 surrogates"=pure40,"Error(40)"=rand40,"60 surrogates"=pure60,"Error(60)"=rand60,"500 surrogates"=pure500,"Error(500)"=rand500)
write.csv(outlierFractionsDF,"C:/Documents and Settings/gillette/My Documents/research/MotifAnalysis/OutlierFractions.csv")

outlierRand0Data2_60 <- getOutliers(2,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=0)

outlierData1_40_rand0set1 <- outlierRandData1_40
outlierData1_40_rand0set1 <- getOutliers(1,sets=40,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=0)
outlierData2_40_rand0set1 <- outlierRandData2_40
outlierData1_40_rand0set2 <- getOutliers(1,sets=40,surrogateSet=2,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=0)
outlierData2_40_rand0set2 <- getOutliers(2,sets=40,surrogateSet=2,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=1)
outlierData1_40_rand100set1 <- getOutliers(1,sets=40,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=100,useRandomK=0)
outlierData2_40_rand100set1 <- getOutliers(2,sets=40,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=100,useRandomK=1)
outlierData1_40_rand100set2 <- getOutliers(1,sets=40,surrogateSet=2,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=100,useRandomK=0)
outlierData2_40_rand100set2 <- getOutliers(2,sets=40,surrogateSet=2,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=100,useRandomK=1)

outlierData1_40_set1 <- outlierData1_40
outlierData2_40_set1 <- outlierData2_40
outlierData1_40_set2 <- getOutliers(1,sets=40,surrogateSet=2,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData2_40_set2 <- getOutliers(2,sets=40,surrogateSet=2,order="LTS",method=8,threshold="0.0",directory=motifDirectory)

outlierData1_60_rand0set1 <- getOutliers(1,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=0)
outlierData2_60_rand0set1 <- getOutliers(2,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=1)
outlierData1_60_rand0set2 <- getOutliers(1,sets=60,surrogateSet=2,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=0)
outlierData2_60_rand0set2 <- getOutliers(2,sets=60,surrogateSet=2,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=1)
outlierData1_60_rand100set1 <- getOutliers(1,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=100,useRandomK=0)
outlierData2_60_rand100set1 <- getOutliers(2,sets=60,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=100,useRandomK=1)
outlierData1_60_rand100set2 <- getOutliers(1,sets=60,surrogateSet=2,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=100,useRandomK=0)
outlierData2_60_rand100set2 <- getOutliers(2,sets=60,surrogateSet=2,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=100,useRandomK=1)

outlierData1_60_set1 <- outlierData1_60
outlierData2_60_set1 <- outlierData2_60
outlierData1_60_set2 <- getOutliers(1,sets=60,surrogateSet=2,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
outlierData2_60_set2 <- getOutliers(2,sets=60,surrogateSet=2,order="LTS",method=8,threshold="0.0",directory=motifDirectory)

dimerCP2_40 <- calculateConditionalProbabilities(outlierRandData2_40,2)
dimerProbs2_40 <- apply(outlierRandData2_40[,3:11],2,mean)
dimerCP2_60 <- calculateConditionalProbabilities(outlierRandData2_60,2)
dimerProbs2_60 <- apply(outlierRandData2_60[,3:11],2,mean)
dimerCP3_60 <- calculateConditionalProbabilities(outlierRandData3_60,3)
dimerProbs3_60 <- apply(outlierRandData3_60[,3:27],2,mean)

outlierRand5K1_1 <- getOutliers(1,sets=20,surrogateSet=5,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=5,useRandomK=1)
getOutliersFilename(1,sets=20,surrogateSet=5,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=5,useRandomK=1)
outlierRand4K1Set6_1 <- getOutliers(1,sets=20,surrogateSet=6,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=4,useRandomK=1)
outlierRand4K2Set6_2 <- getOutliers(2,sets=20,surrogateSet=6,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=4,useRandomK=2)
outlierRand4K1Set6_2 <- getOutliers(2,sets=20,surrogateSet=6,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=4,useRandomK=1)

outliersList1 <- getOutliersList(1,20,random=F,directory=motifDirectory)
outliersRandList1 <- getOutliersList(1,20,random=T,directory=motifDirectory)
outliersList2 <- getOutliersList(2,20,random=F,directory=motifDirectory)
outliersRandList2 <- getOutliersList(2,20,random=T,directory=motifDirectory)
outliersList3 <- getOutliersList(3,20,random=F,directory=motifDirectory)
outliersRandList3 <- getOutliersList(3,20,random=T,directory=motifDirectory)

outliersRand7List2 <- getOutliersList(2,10,random=T,randomSet=7,directory=motifDirectory)

outliersRandList2_R5 <- getOutliersList(2,20,random=T,randomSet=5,directory=motifDirectory)

baselineKmerSignificanceDistribution(1,outliersRandList1,title="Random Monomers")
randFractionMeans1 <- getFractionMeans(outliersRandList1)
randFractionSDs1 <- getFractionSDs(outliersRandList1)
outlierFractionPVals1 <- outlierFractionSignificanceDistribution(outliersRandList1)

baselineKmerSignificanceDistribution(1,outliersList1,title="Real Monomers")
fractionMeans1 <- getFractionMeans(outliersList1)

baselineKmerSignificanceDistribution(2,outliersRandList2,title="Random Dimers")
outlierFractionSignificanceDistribution(outliersRandList2,title="Random Dimers")
randFractionMeans2 <- getFractionMeans(outliersRandList2)
randFractionSDs2 <- getFractionSDs(outliersRandList2)
outlierFractionPVals2 <- outlierFractionSignificanceDistribution(outliersRandList2)

baselineKmerSignificanceDistribution(2,outliersList2,title="Real Dimers")
outlierFractionSignificanceDistribution(outliersList2,title="Real Dimers")
fractionMeans2 <- getFractionMeans(outliersList2)
fractionSDs2 <- getFractionSDs(outliersList2)

baselineKmerSignificanceDistribution(3,outliersRandList3,title="Random Trimers")
randMeanFractions3 <- getMeanFractions(outliersRandList3)
meanFractions3 <- getMeanFractions(outliersList3)
outlierFractionPVals3 <- outlierFractionSignificanceDistribution(outliersRandList3)


wilcox2_4060 <- c(.372,.428,.48,.236,.924,.308,.76,.697,.869)
wilcox2_2060 <- c(.775,.061,.96,.761,.05,.41,.026,.974,.378)
wilcox2_2040 <- c(.076,.409,.129,.718,.04,.474,.799,.138,.652)
wilcox2All <- c(wilcox2_4060,wilcox2_2060,wilcox2_2040)
hist(wilcox2All,breaks=20)
hist(qnorm(wilcox2All))

meanOF(outlierData1_60_rand0set1)

# Use randoms in place of reals for comparison; Method8 STL
outlierRandData2B8STL <- getOutliers(2,order="STL",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=21,useRandomK=1)
outlierRandData3B8STL <- getOutliers(3,order="STL",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=21,useRandomK=2)
outlierRandData4B8STL <- getOutliers(4,order="STL",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=21,useRandomK=3)

#####################################################################
## Get outlier fractions for each kmer, then run paired wilcoxin on 
## them between reals and randoms (analysis 1)

outlierData <- list()
outlierRandData <- list()
nullHDataForK <- list()
for (k in 1:5){
  outlierData[[k]] <- getOutliers(k,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
  outlierRandData[[k]] <- getOutliers(k,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=(k-1))
  kmers <- getKmersForOutlierAnalysis(k,outlierData[[k]])
  for (i in 1:randSets){
    # Kmer p-values
    nullHDataForK[[i]] <- getOutliers(k,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=i,useRandomK=(k-1))
    nullHDataForK[[i]] <- nullHDataForK[[i]][,c(kmers,"OutlierFraction")]
  }
  nullHData[[k]] <- nullHDataForK
}

for (k in 1:5){
  kmers <- getKmersForOutlierAnalysis(k,outlierData[[k]])
  for (i in 1:randSets){
    # Kmer p-values
    nullHData[[k]][[i]]$OutlierFraction <- apply(nullHData[[k]][[i]],1,mean)
  }
}

randSets <- 40

getPValuesAcrossKmerOFsBySubset <- function(arborType=NA,cellType=NA,brainRegion=NA,minLength=NaN,maxLength=NaN,adjustPValues=T){
  subsetSequences <- getSubsetSequences(outlierData[[1]],arborType,cellType,brainRegion,minLength,maxLength)
  indices <- as.numeric(rownames(subset(outlierData[[1]],Sequence%in%subsetSequences)))
  getPValuesAcrossKmerOFs(indices,adjustPValues)
}

getPValuesAcrossKmerOFs <- function(subsetIndices=rep(1:numSequences),adjustPValues=T,test=c("wilcoxin","binomial","poisson")){
  # Store p values using the given method
  kPValuesByKmerOFs <- rep(0,5)
  names(kPValuesByKmerOFs) <- 1:5
  # Adjusted p-values
  adjPValuesByKmerOFs <- rep(0,5)
  names(adjPValuesByKmerOFs) <- 1:5

  nullHPValuesByKmerOFs <- list()

  # Constrained fractions of real sequence kmers, along with means, SDs, and SEs
  realConstrainedFractions <- list()
  realCFMeans <- rep(0,5)
  names(realCFMeans) <- 1:5
  realCFSDs <- rep(0,5)
  realCFSEs <- rep(0,5)

  randConstrainedFractions <- list()
  randCFMeans <- rep(0,5)
  randCFSDs <- rep(0,5)
  randCFSEs <- rep(0,5)

  resultData <- list()

  for (k in 2:5){
    kmers <- getKmersForOutlierAnalysis(k,outlierData[[k]])
    numKmers <- length(kmers)

    subOutlierData <- outlierData[[k]][subsetIndices,]
    subOutlierRandData <- outlierRandData[[k]][subsetIndices,]

    # Calculate outlier fractions for each kmer
    realConstrainedFractionsForK <- rep(0,length(kmers))
    names(realConstrainedFractionsForK) <- kmers
    randConstrainedFractionsForK <- rep(0,length(kmers))
    names(randConstrainedFractionsForK) <- kmers
    for (kmer in kmers){
      realConstrainedFractionsForK[kmer] <- 1-mean(subOutlierData[,kmer])
      randConstrainedFractionsForK[kmer] <- 1-mean(subOutlierRandData[,kmer])
    }
    realConstrainedFractions[[k]] <- realConstrainedFractionsForK
    randConstrainedFractions[[k]] <- randConstrainedFractionsForK

#    kPValuesByKmerOFs[k] <- wilcox.test(realConstrainedFractions[[k]],randConstrainedFractions[[k]],paired=T)$p.value
#    print(kPValuesByKmerOFs[k])
    kPValuesByKmerOFs[k] <- wilcox.test(realConstrainedFractions[[k]],randConstrainedFractions[[k]],paired=T,alternative="less")$p.value
    print(kPValuesByKmerOFs[k])

    # Get CF distribution info for plotting later
    realCFMeans[k] <- mean(realConstrainedFractionsForK)
    randCFMeans[k] <- mean(randConstrainedFractionsForK)
    realCFSDs[k] <- sd(realConstrainedFractionsForK)
    randCFSDs[k] <- sd(randConstrainedFractionsForK)
    realCFSEs[k] <- realCFSDs[k]/sqrt(length(realConstrainedFractionsForK))
    randCFSEs[k] <- randCFSDs[k]/sqrt(length(randConstrainedFractionsForK))

    if (adjustPValues){
      # Run across many sets to enable multi-test comparison and normalization (needed because of more kmers for higher k)
      nullHOFsForK <- matrix(0,randSets,numKmers)
      nullHOFPvalues <- rep(0,randSets)
      for (i in 1:nullHSets){
        # Kmer p-values
        outlierNullHData <- getNullHData(i,k,sets=20,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
        outlierNullHData <- outlierNullHData[subsetIndices,]

        nullHConstrainedFractionsForK <- rep(0,numKmers)
        names(nullHConstrainedFractionsForK) <- kmers
        for (kmer in kmers){
          nullHConstrainedFractionsForK[kmer] <- 1-mean(outlierNullHData[,kmer])
        }
        nullHOFsForK[i,] <- nullHConstrainedFractionsForK
        nullHOFPvalues[i] <- wilcox.test(nullHConstrainedFractionsForK,randConstrainedFractions[[k]],paired=T)$p.value
      }
      nullHPValuesByKmerOFs[[k]] <- nullHOFPvalues
      adjPValuesByKmerOFs[k] <- min(1,(1+sum(nullHPValuesByKmerOFs[[k]] <= kPValuesByKmerOFs[k]))/length(nullHPValuesByKmerOFs[[k]]))
    }
  }
  
  if (adjustPValues){
    resultData$adjPValuesByKmerOFs <- adjPValuesByKmerOFs
  }

  resultData$realCFMeans <- realCFMeans
  resultData$randCFMeans <- randCFMeans
  resultData$realCFSDs <- realCFSDs
  resultData$randCFSDs <- randCFSDs
  resultData$realCFSEs <- realCFSEs
  resultData$randCFSEs <- randCFSEs
  resultData$pValuesByKmerOFs <- kPValuesByKmerOFs
  resultData
}

pAcrossKmerResult <- getPValuesAcrossKmerOFs()
pAcrossKmerResultAbove100 <- getPValuesAcrossKmerOFsBySubset(minLength=100)
pAcrossKmerResultAxon <- getPValuesAcrossKmerOFsBySubset(arborType="Axon")
pAcrossKmerResultBelow200 <- getPValuesAcrossKmerOFsBySubset(maxLength=199)
pAcrossKmerResultBelow100 <- getPValuesAcrossKmerOFsBySubset(maxLength=99)
pAcrossKmerResultDendrite <- getPValuesAcrossKmerOFsBySubset(arborType="Dendrite")

pAcrossKmerResultAbove30 <- getPValuesAcrossKmerOFsBySubset(minLength=30)
pAcrossKmerResultBelow30 <- getPValuesAcrossKmerOFsBySubset(maxLength=29)

# Plot constrained fractions
useSDs <- F
ks <- 2:5
zoomXMin <- .75
space <- .4

plotKmerCFMeansWData(pAcrossKmerResult,2:5,zoomXMin=.75,space=.2,useSDs=F,useUnadjustedPs=T)

plotKmerCFMeansWData(pAcrossKmerResult,4:5,zoomXMin=.75,space=.6,useSDs=F,useUnadjustedPs=T)

plotKmerCFMeansWData <- function(data=NULL,ks,GroupTitle=NULL,zoomXMin=0,space=.6,useSDs=F,useUnadjustedPs=F){
  if (useSDs){
    realErr <- data$realCFSDs
    randErr <- data$randCFSDs
  }
  else{
    realErr <- data$realCFSEs
    randErr <- data$randCFSEs
  }
  if (useUnadjustedPs){
    pValues <- data$pValuesByKmerOFs
  }
  else{
    pValues <- data$adjPValuesByKmerOFs
  }
  plotKmerCFMeans(data$realCFMeans,data$randCFMeans,ks,realErr,randErr,GroupTitle,pValues,zoomXMin,space,useSDs)
}
plotKmerCFMeans <- function(realCFMeans,randCFMeans,ks,realCFErr=NULL,randCFErr=NULL,GroupTitle=NULL,pValues=NULL,zoomXMin=0,space=.6,useSDs=F){
  x11()
  plotmatrix <- matrix(c(realCFMeans[ks],randCFMeans[ks]),length(ks),2)
  colnames(plotmatrix) <- c("Real sequences","Random sequences")
  if (!is.null(pValues)){
    rownames(plotmatrix) <- paste(ks," (p<",format(pValues[ks],scientific=T,digits=2),")",sep="")
  }
  else{
    rownames(plotmatrix) <- ks
  }
  title <- "Mean Constrained Fractions\nAcross Kmers for K"
  if (useSDs){
    title <- paste(title,"(StdDevs)")
  }
  else{
    title <- paste(title,"(SEMs)")
  }
  if (!is.null(GroupTitle)){
    title <- paste(title,"\n",GroupTitle,sep="")
  }
  barplot(t(plotmatrix)-zoomXMin,beside=T,space=c(0,space),xlab="K",legend=T,ylab="Kmers Constrained Fraction",ylim=c(zoomXMin,1),offset=zoomXMin,args.legend=list(x=(2+space)*length(ks)*.75,y=(1-zoomXMin)*.25+zoomXMin,bg="White"),main=title)

  lines(x=c(0,length(ks)*(2+space)),y=c(1,1),lty=2)
  for (i in 1:length(ks)){
    k <- ks[i]
    pos <- .5+space+(2+space)*(i-1)
    lines(x=c(pos,pos),y=realCFMeans[k]+realCFErr[k]*c(-1,1))
    lines(x=c(pos-.25,pos+.25),y=realCFMeans[k]+realCFErr[k]*c(1,1))
    lines(x=c(pos-.25,pos+.25),y=realCFMeans[k]+realCFErr[k]*c(-1,-1))

    pos <- pos+1
    lines(x=c(pos,pos),y=randCFMeans[k]+randCFErr[k]*c(-1,1))
    lines(x=c(pos-.25,pos+.25),y=randCFMeans[k]+randCFErr[k]*c(1,1))
    lines(x=c(pos-.25,pos+.25),y=randCFMeans[k]+randCFErr[k]*c(-1,-1))
  }
}

plotKmerRemainingOFMeans <- function(realOutlierData,randOutlierData,ks=1:length(realOutlierData),GroupTitle=NULL){
  x11()
  realOFMeans <- c()
  randOFMeans <- c()
  realOFSEs <- c()
  randOFSEs <- c()
  combinedSEs <- c()
  for (k in ks){
    realOFs <- apply(realOutlierData[[k]],1,mean)
    randOFs <- apply(randOutlierData[[k]],1,mean)
    realOFMeans[k] <- mean(realOFs)
    randOFMeans[k] <- mean(randOFs)
    realOFSEs[k] <- sd(realOFs)/sqrt(nrow(realOutlierData[[k]]))
    randOFSEs[k] <- sd(randOFs)/sqrt(nrow(realOutlierData[[k]]))
    combinedSEs[k] <- realOFSEs[k]+randOFSEs[k]
  }
  plotmatrix <- matrix(c(realOFMeans[ks],randOFMeans[ks]),length(ks),2)
  colnames(plotmatrix) <- c("Real sequences","Random sequences")
  rownames(plotmatrix) <- ks
  title <- "Mean Unconstrained Fractions Above Chance\nAcross Kmers for K"
  if (!is.null(GroupTitle)){
    title <- paste(title,"\n",GroupTitle,sep="")
  }
  
  #barplot(t(plotmatrix)-zoomXMin,beside=T,space=c(0,space),xlab="K",legend=T,ylab="Kmers Constrained Fraction",ylim=c(zoomXMin,1),offset=zoomXMin,args.legend=list(x=(2+space)*length(ks)*.75,y=(1-zoomXMin)*.25+zoomXMin,bg="White"),main=title)
  barplot(realOFMeans-randOFMeans,xlab="K",ylab="Kmers Unconstrained Fraction Above Chance",main=title,ylim=c(0,1.2*max(realOFMeans-randOFMeans)))
  
  #lines(x=c(0,length(ks)*(2+space)),y=c(1,1),lty=2)
  for (i in 1:length(ks)){
    k <- ks[i]
    pos <- .7+1.2*(i-1)
    ypos <- realOFMeans[k]-randOFMeans[k]
    err <- (realOFSEs[k]+randOFSEs[k])
    lines(x=c(pos,pos),y=ypos+err*c(-1,1))
    lines(x=c(pos-.25,pos+.25),y=ypos+err*c(1,1))
    lines(x=c(pos-.25,pos+.25),y=ypos+err*c(-1,-1))
  }
}

#######################################
# Run above analysis on samples
subsetSequences <- getSubsetSequences(outlierData[[1]],maxLength=99)
below100SampleInds <- sample(as.numeric(rownames(subset(outlierData[[1]],Sequence%in%subsetSequences))))[1:407]
pAcrossKmerResultBelow100Sample <- getPValuesAcrossKmerOFs(below100SampleInds)

#Determine the data subset (if any)
subsetSequences <- getSubsetSequences(outlierData[[1]],maxLength=99)
subsetSequences <- getSubsetSequences(outlierData[[1]],minLength=150)
subsetSequences <- getSubsetSequences(outlierData[[1]])

pAcrossKmerResult150Up <- getPValuesAcrossKmerOFsBySubset(minLength=150,adjustPValues=F)

sampleSize <- 200
numSamples <- 20
#samplePValues <- list()
# Set up p-value matrix for the samples and the k-mers
#for (k in 2:5){
#  kmers <- getKmersForOutlierAnalysis(k,outlierData[[k]])
#  numKmers <- length(kmers)
#}

samplePValues <- matrix(0,numSamples,5)
sampleCFMeans <- matrix(0,numSamples,5)
for (i in 1:numSamples){
  sampleInds <- sample(as.numeric(rownames(subset(outlierData[[1]],Sequence%in%subsetSequences))))[1:sampleSize]
  pAcrossKmerResultSample <- getPValuesAcrossKmerOFs(sampleInds,adjustPValues=F)
  samplePValues[i,] <- pAcrossKmerResultSample$pValuesByKmerOFs
  sampleCFMeans[i,] <- pAcrossKmerResultSample$realCFMeans
}

#####################################

############################################################################################
## Paired Wilcoxin of outlier statuses across kmers (analysis 3) against a random set compared to 
## the same of random against random, <nullHSets> times to get adjusted p-value (Westfall&Young).
## Also paired Wilcoxin of sequence outlier fractions (analysis 2)
##   Full set of tests for k 1:5, and for all kmers at each k
## Added mean/SD/SEM of outlier fractions across sequences, maybe used for FIG 1 of paper

usePRs <- T
outlierData <- list()
outlierRandData <- list()
for (k in 1:5){
  if (usePRs){
    prData <- read.csv(getPRFilename(k,sets=40,surrogateSet=7,order="LTS",method=8,threshold="0.0",thresholdTypeString="Whole",directory=prDataDirectory,sourceTraversal="LTS"),stringsAsFactors=F,row.names=1)
    if (k > 2){
      stlPRData <- read.csv(getPRFilename(k,sets=40,surrogateSet=7,order="LTS",method=8,threshold="0.0",thresholdTypeString="Whole",directory=prDataDirectory,sourceTraversal="STL"),stringsAsFactors=F,row.names=1)
      stlPRData <- colnames(stlPRData) <- paste("s",colnames(stlPRData),sep="")
      stlPRData <- stlPRData[,!grepl("s[ACT]C+[ACT]",colnames(stlPRData))]
      # just make sure they have the same sequences and order of seqs
      sharedSeqs <- intersect(rownames(prData),rownames(stlData))
      prData <- cbind(prData,stlPRData)
      # Remove ATT
      prData <- prData[,colnames(prData)!="sATT"&colnames(prData)!="ATT"]
    }
    outlierData[[k]] <- prData < .025 | prData > .975
    
    prData <- read.csv(getPRFilename(k,sets=40,surrogateSet=5,order="LTS",method=8,useRandomSet=1,useRandomK=k-1,threshold="0.0",thresholdTypeString="Whole",directory=prDataDirectory,sourceTraversal="LTS"),stringsAsFactors=F,row.names=1)
    if (k > 2){
      stlPRData <- read.csv(getPRFilename(k,sets=40,surrogateSet=5,order="LTS",method=8,threshold="0.0",thresholdTypeString="Whole",directory=prDataDirectory,sourceTraversal="STL"),stringsAsFactors=F,row.names=1)
      stlPRData <- colnames(stlPRData) <- paste("s",colnames(stlPRData),sep="")
      stlPRData <- stlPRData[,!grepl("s[ACT]C+[ACT]",colnames(stlPRData))]
      # just make sure they have the same sequences and order of seqs
      sharedSeqs <- intersect(rownames(prData),rownames(stlData))
      prData <- cbind(prData,stlPRData)
      prData <- prData[,colnames(prData)!="sATT"&colnames(prData)!="ATT"]
    }
    outlierRandData[[k]] <- prData < .025 | prData > .975
  }
  else{
    outlierData[[k]] <- getOutliers(k,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
    outlierRandData[[k]] <- getOutliers(k,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=(k-1))
  }
#  kmers <- getKmersForOutlierAnalysis(k,outlierData[[k]])
#  for (i in 1:randSets){
#    # Kmer p-values
#    nullHDataForK[[i]] <- getOutliers(k,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=i,useRandomK=(k-1))
#    nullHDataForK[[i]] <- nullHDataForK[[i]][,c(kmers,"OutlierFraction")]
#  }
#  nullHData[[k]] <- nullHDataForK
}

numSequences <- dim(outlierData[[1]])[1]
nullHSets <- 40

getKmerOFsAndPValuesBySubset <- function(arborType=NA,cellType=NA,brainRegion=NA,minLength=NaN,maxLength=NaN,test=c("wilcoxin","binomial","poisson"),multipleTestingCorrection=F){
  subsetSequences <- getSubsetSequences(outlierData[[1]],arborType,cellType,brainRegion,minLength,maxLength)
  indices <- as.numeric(rownames(subset(outlierData[[1]],Sequence%in%subsetSequences)))
#  print(indices)
  getKmerOFsAndPValues(indices,test=test,multipleTestingCorrection=multipleTestingCorrection)
}

getKmerOFsAndPValues <- function(subsetIndices=1:dim(outlierData[[1]])[1],debug=F,test=c("wilcoxin","binomial","poisson"),multipleTestingCorrection=F){
  # Read in all the relevant data and run raw p-value calculations
  rawOutlierPValues <- rep(0,5)
  rawKmerPValues <- list()

  realCFMeans <- rep(0,5)
  randCFMeans <- rep(0,5)
  realCFSDs <- rep(0,5)
  randCFSDs <- rep(0,5)
  realCFSEs <- rep(0,5)
  randCFSEs <- rep(0,5)

  for (k in 1:5){
    if (debug){
      print(paste("K",k))
    }
    kmers <- getKmersForOutlierAnalysis(k,outlierData[[k]])
    numKmers <- length(kmers)

    subOutlierData <- outlierData[[k]][subsetIndices,]
    subOutlierRandData <- outlierRandData[[k]][subsetIndices,]

    # Calculate raw p-values for outlier fractions
    rawOutlierPValues[k] <- wilcox.test(subOutlierData$OutlierFraction,subOutlierRandData$OutlierFraction,paired=T,alternative="greater")$p.value

    # Calculate outlier fraction means,SDs, and SEMs
    numSequences <- length(subOutlierData$OutlierFraction)
    realCFMeans[k] <- mean(subOutlierData$OutlierFraction)
    randCFMeans[k] <- mean(subOutlierRandData$OutlierFraction)
    realCFSDs[k] <- sd(subOutlierData$OutlierFraction)
    randCFSDs[k] <- sd(subOutlierRandData$OutlierFraction)
    realCFSEs[k] <- sd(subOutlierData$OutlierFraction)/sqrt(numSequences)
    randCFSEs[k] <- sd(subOutlierRandData$OutlierFraction)/sqrt(numSequences)

    # Calculate raw p-values for each kmer (using either wilcox.test, binom.test, or poisson.test)
    rawKmerPValuesForK <- rep(0,numKmers)
    names(rawKmerPValuesForK) <- kmers
    for (kmer in kmers){
      #rawKmerPValuesForK[kmer] <- wilcox.test(subOutlierData[,kmer],subOutlierRandData[,kmer],paired=T,alternative="greater")$p.value
      rawKmerPValuesForK[kmer] <- runStatTest(subOutlierData[,kmer],subOutlierRandData[,kmer],test=test,alternative="greater")$p.value
      if (is.nan(rawKmerPValuesForK[kmer])){
        rawKmerPValuesForK[kmer] <- 1
      }
    }
    rawKmerPValues[[k]] <- rawKmerPValuesForK

    # Pul null hypothesis data and produce null hypothesis p-values
    if (multipleTestingCorrection){
      outlierNullHMatrices <- list()
      acrossKNullHMatrix <- matrix(0,nullHSets,5)
      pValues <- rep(0,numKmers)
      names(pValues) <- kmers
      pValMat <- matrix(0,nullHSets,numKmers)
      orderMat <- matrix(0,nullHSets,numKmers)
      for (i in 1:nullHSets){
        # Kmer p-values
        if (debug){
          print(paste("Working on nullH set",i))
        }
        outlierNullHData <- getNullHData(i,k,sets=20,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
        outlierNullHData <- outlierNullHData[subsetIndices,]
        for (kmer in kmers){
          #pValues[kmer] <- wilcox.test(outlierNullHData[,kmer],subOutlierRandData[,kmer],paired=T,alternative="greater")$p.value
          pValues[kmer] <- runStatTest(outlierNullHData[,kmer],subOutlierRandData[,kmer],test=test,alternative="greater")$p.value
          if (is.nan(pValues[kmer])){
            pValues[kmer] <- 1
          }
        }
        pValMat[i,] <- sort(pValues)
        orderMat[i,] <- order(pValues)
  
        # Outlier fraction p-value
        acrossKNullHMatrix[i,k] <- wilcox.test(outlierNullHData$OutlierFraction,subOutlierRandData$OutlierFraction,paired=T,alternative="greater")$p.value
      }
      outlierNullHMatrices[[k]] <- pValMat
    }
  }

  # Adjusted p-values for multiple testing across k 1:5
  if (multipleTestingCorrection){
    adjustedOFPvalues <- adjustedPWestfallYoung(rawOutlierPValues,acrossKNullHMatrix)
    # Adjusted p-values for multiple testing across kmers
    kmerAdjustedPValues <- list()
    for (k in 1:5){
      # Outlier fraction P-values across k 1:5
      kmerAdjustedPValues[[k]] <- adjustedPWestfallYoung(rawKmerPValues[[k]],outlierNullHMatrices[[k]],lessThan=T)
    }
  }

  resultData <- list()

  resultData$realSeqOFMeans <- realCFMeans
  resultData$randSeqOFMeans <- randCFMeans
  resultData$realSeqOFSDs <- realCFSDs
  resultData$randSeqOFSDs <- randCFSDs
  resultData$realSeqOFSEs <- realCFSEs
  resultData$randSeqOFSEs <- randCFSEs

  resultData$rawKmerPValues <- rawKmerPValues
  resultData$rawOutlierPValues <- rawOutlierPValues
  if (multipleTestingCorrection){
    resultData$kmerAdjustedPValues <- kmerAdjustedPValues
    resultData$adjustedOFPValues <- adjustedOFPvalues
  }
  resultData
}

allKmerOFResult <- getKmerOFsAndPValues() # Wilcoxin is default
allKmerOFResultPoisson <- getKmerOFsAndPValues(test="poisson")
allKmerOFResultBinomial <- getKmerOFsAndPValues(test="binomial")
kmerOFResultAbove200 <- getKmerOFsAndPValuesBySubset(minLength=200,test="poisson")
kmerOFResultAbove100 <- getKmerOFsAndPValuesBySubset(minLength=100,test="poisson")
kmerOFResultAbove50_100 <- getKmerOFsAndPValuesBySubset(minLength=50,maxLength=100,test="poisson")
kmerOFResultAxon <- getKmerOFsAndPValuesBySubset(arborType="Axon")
kmerOFResultBelow200 <- getKmerOFsAndPValuesBySubset(maxLength=199)
kmerOFResultDendrite <- getKmerOFsAndPValuesBySubset(arborType="Dendrite")
kmerOFResultApical <- getKmerOFsAndPValuesBySubset(arborType="ApicalDendrite")


for (k in 1:5){
  print(kmerAdjustedPValues[[k]][kmerAdjustedPValues[[k]]<=.05])
}

## End Wilcoxin/Westfall&Young p-value analysis
###############################################################
## Plot outlier fraction mean/SEM across sequences?

plotSequenceCFMeansWData <- function(data=NULL,ks=1:5,flipRandoms=T,GroupTitle=NULL,zoomXMin=0,space=.35,useSDs=F,writePValues=F,useUnadjustedPs=F){
  if (useSDs){
    realErr <- data$realSeqOFSDs
    randErr <- data$randSeqOFSDs
  }
  else{
    realErr <- data$realSeqOFSEs
    randErr <- data$randSeqOFSEs
  }
  if (writePValues){
    if (useUnadjustedPs){
      pValues <- data$rawOutlierPValues
    }
    else{
      pValues <- data$adjustedOFPValues
    }
  }
  else{
    pValues <- NULL
  }
  plotSequenceCFMeans(data$realSeqOFMeans,data$randSeqOFMeans,ks,flipRandoms,realErr,randErr,GroupTitle,pValues,zoomXMin,space,useSDs)
}
plotSequenceCFMeans <- function(realOFMeans,randOFMeans,ks=1:5,mode=c("none","flipRandoms","difference"),realCFErr=NULL,randCFErr=NULL,GroupTitle=NULL,pValues=NULL,zoomXMin=0,space=.35,useSDs=F,shiftErr=F){
  mode <- match.arg(mode)
  x11()

  realOFMeans <- realOFMeans[ks]
  randOFMeans <- randOFMeans[ks]

  realCFMeans <- 1-realOFMeans
  randCFMeans <- 1-randOFMeans
  names(realCFMeans) <- ks

  # Create the title
  title <- "Mean Constrained Fractions\nAcross Sequences for K"
  if (useSDs){
    title <- paste(title,"(StdDevs)")
  }
  else{
    title <- paste(title,"(SEMs)")
  }
  if (!is.null(GroupTitle)){
    title <- paste(title,"\n",GroupTitle,sep="")
  }

  if (mode == "flipRandoms"){
    barplot(realCFMeans-zoomXMin,space=space,main=title,xlab="K",ylab="Average Sequence Constrained Fraction",ylim=c(zoomXMin,1),offset=zoomXMin,col="gray95",legend=T,args.legend=list(x=(2+space)*length(ks)*.75,y=(1-zoomXMin)*.25+zoomXMin,bg="White"))
    lines(x=c(0,length(ks)*(1+space)),y=c(1,1),lty=2)
    barplot(randOFMeans,offset=randCFMeans,space=space,add=T,col="gray68",border="gray34")
    for (i in 1:length(ks)){
      k <- ks[i]
      pos <- .5+space+(1+space)*(i-1)
      lines(x=c(pos,pos),y=realCFMeans[i]+realCFErr[k]*c(-1,1))
      lines(x=c(pos-.15,pos+.15),y=realCFMeans[i]+realCFErr[k]*c(1,1))
      lines(x=c(pos-.15,pos+.15),y=realCFMeans[i]+realCFErr[k]*c(-1,-1))

      # Small offset to avoid overlap of error bars
      if (shiftErr){
        pos <- pos + .03
      }
      lines(x=c(pos,pos),y=randCFMeans[k]+randCFErr[k]*c(-1,1),col="gray20")
      lines(x=c(pos-.15,pos+.15),y=randCFMeans[k]+randCFErr[k]*c(1,1),col="gray20")
      lines(x=c(pos-.15,pos+.15),y=randCFMeans[k]+randCFErr[k]*c(-1,-1),col="gray20")
    }
  }
  else if (mode == "difference"){
    diffs <- realCFMeans-randOFMeans
    barplot(realCFMeans-randOFMeans,space=space,main=title,xlab="K",ylab="Proportion of n-mers constrained above chance",col="gray95")
    #lines(x=c(0,length(ks)*(1+space)),y=c(1,1),lty=2)
    #barplot(randOFMeans,offset=randCFMeans,space=space,add=T,col="gray68",border="gray34")
    for (i in 1:length(ks)){
      k <- ks[i]
      pos <- .5+space+(1+space)*(i-1)
      lines(x=c(pos,pos),y=diffs[k]+(realCFMeans[k]+realCFErr[k])*c(-1,1))
      lines(x=c(pos-.15,pos+.15),y=diffs[k]+(realCFMeans[k]+realCFErr[k])*c(1,1))
      lines(x=c(pos-.15,pos+.15),y=diffs[k]+(realCFMeans[k]+realCFErr[k])*c(-1,-1))
    }
  }
  else{
    plotmatrix <- matrix(c(realCFMeans[ks],randCFMeans[ks]),length(ks),2)
    colnames(plotmatrix) <- c("Real sequences","Random sequences")
    if (!is.null(pValues)){
      rownames(plotmatrix) <- paste(ks," (p<",format(pValues[ks],scientific=T,digits=2),")",sep="")
    }
    else{
      rownames(plotmatrix) <- ks
    }
    barplot(t(plotmatrix)-zoomXMin,beside=T,space=c(0,space),main=title,xlab="K",ylab="Average Sequence Constrained Fraction",ylim=c(zoomXMin,1),offset=zoomXMin,legend=T,args.legend=list(x=(2+space)*length(ks)*.75,y=(1-zoomXMin)*.25+zoomXMin,bg="White"))

    lines(x=c(0,length(ks)*(2+space)),y=c(1,1),lty=2)
    for (i in 1:length(ks)){
      k <- ks[i]
      pos <- .5+space+(2+space)*(i-1)
      lines(x=c(pos,pos),y=realCFMeans[k]+realCFErr[k]*c(-1,1))
      lines(x=c(pos-.15,pos+.15),y=realCFMeans[k]+realCFErr[k]*c(1,1))
      lines(x=c(pos-.15,pos+.15),y=realCFMeans[k]+realCFErr[k]*c(-1,-1))

      pos <- pos+1
      lines(x=c(pos,pos),y=randCFMeans[k]+randCFErr[k]*c(-1,1))
      lines(x=c(pos-.15,pos+.15),y=randCFMeans[k]+randCFErr[k]*c(1,1))
      lines(x=c(pos-.15,pos+.15),y=randCFMeans[k]+randCFErr[k]*c(-1,-1))
    }
  }
}

plotSequenceCFDistributions <- function(outlierData,outlierRandData,ks=1:5,GroupTitle=NULL,zoomXMin=0,space=.35){
  x11()

  realOFMeans <- rep(0,5)
  realP95 <- rep(0,5)
  randOFMeans <- rep(0,5)
  randP95 <- rep(0,5)
  numSequences <- length(outlierData[[1]]$OutlierFraction)
  for (k in ks){
    realOFMeans[k] <- mean(outlierData[[k]]$OutlierFraction)
    realP95[k] <- 1-sort(outlierData[[k]]$OutlierFraction)[floor(.95*numSequences)]
    randOFMeans[k] <- mean(outlierRandData[[k]]$OutlierFraction)
    randP95[k] <- 1-sort(outlierRandData[[k]]$OutlierFraction)[floor(.95*numSequences)]
  }
  realCFMeans <- 1-realOFMeans
  randCFMeans <- 1-randOFMeans
  names(realCFMeans) <- ks

  # Create the title
  title <- "Mean Constrained Fractions\nAcross Sequences for K"
  if (!is.null(GroupTitle)){
    title <- paste(title,"\n",GroupTitle,sep="")
  }

  plotmatrix <- matrix(c(realCFMeans[ks],randCFMeans[ks]),length(ks),2)
  colnames(plotmatrix) <- c("Real sequences","Random sequences")
  if (!is.null(pValues)){
    rownames(plotmatrix) <- paste(ks," (p<",format(pValues[ks],scientific=T,digits=2),")",sep="")
  }
  else{
    rownames(plotmatrix) <- ks
  }
  barplot(t(plotmatrix)-zoomXMin,beside=T,space=c(0,space),main=title,xlab="K",ylab="Sequence Constrained Fractions Proportion",ylim=c(zoomXMin,1),offset=zoomXMin,legend=T,args.legend=list(x=(2+space)*length(ks)*.75,y=(1-zoomXMin)*.25+zoomXMin,bg="White"))

  # Overwrite boxes with proportion taken by each Constrained Fraction
  for (k in ks){
    OFValues <- sort(unique(outlierData[[k]]$OutlierFraction))
    for (i in 1:length(OFValues)){
      
    }
    OFProportions <- list()


  }

}

plotSequenceCFDistributions(outlierData,outlierRandData,flipRandoms=T)

plotSequenceCFMeansWData(allKmerOFResult,flipRandoms=T,useSDs=F)
plotSequenceCFMeansWData(allKmerOFResult,flipRandoms=T,useSDs=F,zoomXMin=.8)
plotSequenceCFMeansWData(allKmerOFResult,flipRandoms=T,useSDs=F,ks=3:5,zoomXMin=.95)


###############################################################################
# P-value for each sequence (wilcoxin across kmers - Analysis 4), then look at distribution 
# of p-values across sequences

outlierData <- list()
outlierRandData <- list()
nullHData <- list()
for (k in 1:5){
  outlierData[[k]] <- getOutliers(k,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
  outlierRandData[[k]] <- getOutliers(k,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=(k-1))
  nullHDataForK <- list()
  kmers <- getKmersForOutlierAnalysis(k,outlierData[[k]])
  for (i in 1:randSets){
    # Kmer p-values
    nullHDataForK[[i]] <- getOutliers(k,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=i,useRandomK=(k-1))
    nullHDataForK[[i]] <- nullHDataForK[[i]][,c(kmers,"OutlierFraction")]
  }
  nullHData[[k]] <- nullHDataForK
}

randSets <- 40
numSequences <- dim(outlierData[[1]])[1]
sequenceKmerPValues <- list()
sequenceKmerBonfPValues <- list()
sequenceKmerHolmPValues <- list()
sequenceKmerWestfallPValues <- list()
runWestfall <- T

for (k in 2:5){
  pValues <- rep(0,numSequences)
  kmers <- getKmersForOutlierAnalysis(k,outlierData[[k]])
  for (i in 1:numSequences){
    pValues[i] <- wilcox.test(as.numeric(outlierData[[k]][i,kmers]),as.numeric(outlierRandData[[k]][i,kmers]),paired=T,alternative="greater")$p.value
    if (is.nan(pValues[i])){
      pValues[i] <- 1
    }
  }
  sequenceKmerPValues[[k]] <- pValues
  numSeqs <- length(pValues)

  # Holm and Bonferoni adjustments
  pOrder <- order(pValues)
  holmPs <- rep(0,numSeqs)
  bonfPs <- rep(0,numSeqs)
  for (i in 1:numSeqs){
    ind <- pOrder[i]
    bonfPs[ind] <- pValues[ind]*numSeqs
    if (is.nan(bonfPs[ind]) || bonfPs[ind] > 1){
      bonfPs[ind] <- 1
    }
    holmPs[ind] <- pValues[ind]*(numSeqs-i+1)
    if (is.nan(holmPs[ind]) || holmPs[ind] > 1){
      holmPs[ind] <- 1
    }
  }
  sequenceKmerBonfPValues[[k]] <- bonfPs
  sequenceKmerHolmPValues[[k]] <- holmPs  

  print(paste("K:",k))
  print("Raw Ps:")
  print(sort(pValues)[1:30])
  print("Bonferonni Ps:")
  print(sort(bonfPs)[1:30])
  print("Holm Ps:")
  print(sort(holmPs)[1:30])

  if (runWestfall){
    kInds <- 3:(2+length(kmers))
    nullHSeqPVals <- matrix(0,randSets,numSeqs)
    for (i in 1:randSets){
      print(paste("Done",i))
      # Kmer p-values
      outlierNullHData <- getNullHData(i,k,sets=20,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
#      outlierNullHData <- outlierNullHData[subsetIndices,]
      for (j in 1:numSequences){
        nullHSeqPVals[i,j] <- wilcox.test(as.numeric(outlierNullHData[j,]),as.numeric(outlierRandData[[k]][j,kInds]),paired=T,alternative="greater")$p.value
        if (is.nan(nullHSeqPVals[i,j])){
          nullHSeqPVals[i,j] <- 1
        }
      }
    }
    westfallPs <- adjustedPWestfallYoung(pValues,nullHSeqPVals,lessThan=T)
    sequenceKmerWestfallPValues[[k]] <- westfallPs
    print("Westfall&Young Ps:")
    print(sort(westfallPs)[1:30])
  }
}

for (k in 2:5){
  print(paste("K:",k))
  print(paste("Outlier sequences (no correction) proportion: ",mean(sequenceKmerPValues[[k]]<=.05),sep=""))
  print(paste("Outlier sequences (Bonferonni) proportion: ",mean(sequenceKmerBonfPValues[[k]]<=.05),sep=""))
  print(paste("Outlier sequences (Holm) proportion: ",mean(sequenceKmerHolmPValues[[k]]<=.05),sep=""))
  print(paste("Outlier sequences (Westfall&Young) proportion: ",mean(sequenceKmerWestfallPValues[[k]]<=.05),sep=""))
}

#####################################################################
## P-value analysis only with outlier fractions. Looking for p-value "target"
##   Sequences are outliers if (x/n) of their kmers are outliers

outlierData <- list()
outlierRandData <- list()
nullHDataForK <- list()
for (k in 1:5){
  outlierData[[k]] <- getOutliers(k,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
  outlierRandData[[k]] <- getOutliers(k,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=0,useRandomK=(k-1))
  kmers <- getKmersForOutlierAnalysis(k,outlierData[[k]])
  for (i in 1:randSets){
    # Kmer p-values
    nullHDataForK[[i]] <- getOutliers(k,sets=20,surrogateSet=1,order="LTS",method=8,threshold="0.0",directory=motifDirectory,useRandomSet=i,useRandomK=(k-1))
    nullHDataForK[[i]] <- nullHDataForK[[i]][,c(kmers,"OutlierFraction")]
  }
  nullHData[[k]] <- nullHDataForK
}

kmerOutlierCutoff <- 0.05

randSets <- 40

# Read in all the relevant data and run raw p-value calculations
rawConstrainedFractions <- rep(0,5)
names(rawConstrainedFractions) <- 1:5
randConstrainedFractions <- matrix(0,5,randSets)
rawKmerOFs <- list()
randOutlierFractions <- list()
for (k in 1:5){
  kmers <- getKmersForOutlierAnalysis(k,outlierData[[k]])
  numKmers <- length(kmers)

  # Calculate outlier fractions for k
  rawConstrainedFractions[k] <- sum(outlierData[[k]]$OutlierFraction <= kmerOutlierCutoff)/length(outlierData[[k]]$OutlierFraction)
  
  # Calculate outlier fractions for each kmer
  rawKmerOFsForK <- rep(0,numKmers)
  names(rawKmerPValuesForK) <- kmers
  for (kmer in kmers){
    rawKmerOFsForK[kmer] <- sum(outlierData[[k]][,kmer])/length(outlierData[[k]][,kmer])
  }
  rawKmerOFs[[k]] <- rawKmerOFsForK

  # Pull null hypothesis data and produce null hypothesis p-values
  kmerOFs <- rep(0,numKmers)
  names(kmerOFs) <- kmers
  OFMat <- matrix(0,randSets,numKmers)
  randOutlierFractionsForK <- c()
  for (i in 1:nullHSets){
    outlierNullHData <- getNullHData(i,k,sets=20,order="LTS",method=8,threshold="0.0",directory=motifDirectory)
    randOutlierFractionsForK <- c(randOutlierFractionsForK,outlierRandDF$OutlierFraction)
    randConstrainedFractions[k,i] <- sum(outlierNullHData$OutlierFraction <= kmerOutlierCutoff)/length(outlierNullHData$OutlierFraction)
    for (kmer in kmers){
      kmerOFs[kmer] <- sum(outlierNullHData[,kmer])/length(outlierNullHData[,kmer])
    }
  }
  randOutlierFractions[[k]] <- randOutlierFractionsForK
}

meanRandConstrainedFractions <- apply(randConstrainedFractions,1,mean)
sdRandConstrainedFractions <- apply(randConstrainedFractions,1,sd)
seRandConstrainedFractions <- apply(randConstrainedFractions,1,sd)/sqrt(dim(randConstrainedFractions)[1])

# Plots of sequence constrained fractions and random outlier fractions from top

x11()
zoomXMin <- .5
barplot(rawConstrainedFractions-zoomXMin,xlab="K",ylab="Proportion Constrained",ylim=c(zoomXMin,1),col="gray88",offset=zoomXMin)
lines(x=c(0,6),y=c(1,1))
barplot(1-meanRandConstrainedFractions,offset=meanRandConstrainedFractions,add=T,col="gray58")
for (k in 1:5){
  pos <- .7+1.2*(k-1)
  lines(x=c(pos,pos),y=meanRandConstrainedFractions[k]+seRandConstrainedFractions[k]*c(-1,1))
  lines(x=c(pos-.25,pos+.25),y=meanRandConstrainedFractions[k]+seRandConstrainedFractions[k]*c(1,1))
  lines(x=c(pos-.25,pos+.25),y=meanRandConstrainedFractions[k]+seRandConstrainedFractions[k]*c(-1,-1))
}

x11()
zoomXMin <- .95
barplot(rawConstrainedFractions[4:5]-zoomXMin,xlab="K",ylab="Proportion Constrained",ylim=c(zoomXMin,1),col="gray88",offset=zoomXMin)
lines(x=c(0,3),y=c(1,1))
barplot(1-meanRandConstrainedFractions[4:5],offset=meanRandConstrainedFractions[4:5],add=T,col="gray58")
for (i in 1:2){
  pos <- .7+1.2*(i-1)
  k <- i+3
  lines(x=c(pos,pos),y=meanRandConstrainedFractions[k]+sdRandConstrainedFractions[k]*c(-1,1))
  lines(x=c(pos-.25,pos+.25),y=meanRandConstrainedFractions[k]+sdRandConstrainedFractions[k]*c(1,1))
  lines(x=c(pos-.25,pos+.25),y=meanRandConstrainedFractions[k]+sdRandConstrainedFractions[k]*c(-1,-1))
}

## End p-value analysis only with outlier fractions.
#####################################################################
# Look at outlier fraction distributions

x11()
hist(randOutlierFractions[[5]],main="Random Outlier Fractions")
x11()
hist(outlierData[[5]]$OutlierFraction,main="Real Outlier Fractions")

# remove all zeros
breaks <- (0:20)/200
randOutlierFractions5No0 <- randOutlierFractions[[5]][randOutlierFractions[[5]]>0]
x11()
hist(randOutlierFractions5No0,breaks=breaks,main="Random Outlier Fractions (zeros removed)")
outlierFractions5No0 <- outlierData[[5]]$OutlierFraction[outlierData[[5]]$OutlierFraction>0]
x11()
hist(outlierFractions5No0,breaks=breaks,main="Real Outlier Fractions (zeros removed)")

#####################################################################
## Sequences as outliers based on proportion of k-mers that are outliers

sequenceOutlierFraction1 <- rep(0,5)
sequenceOutlierFraction2 <- rep(0,5)
sequenceOutlierFraction3 <- rep(0,5)
maxKmerOutlierCount <- rep(0,5)
for (k in 1:5){
  kmers <- getKmersForOutlierAnalysis(k,outlierData[[k]])
  numKmers <- length(kmers)
  outlierCutoff1 <- 0
  outlierCutoff2 <- floor(numKmers*.05)
  outlierCutoff3 <- floor(numKmers*.1)
  sequenceOutlierFraction1[k] <- mean(outlierData[[k]]$OutlierFraction>outlierCutoff1)
  sequenceOutlierFraction2[k] <- mean(outlierData[[k]]$OutlierFraction>outlierCutoff2)
  sequenceOutlierFraction3[k] <- mean(outlierData[[k]]$OutlierFraction>outlierCutoff3)
  maxKmerOutlierCount[k] <- max(outlierData[[k]]$OutlierFraction)*numKmers
}


#####################################################################
# Compare using different numbers of surrogates per real
wilcox.test(outlierRandData2_20$OutlierFraction,outlierRandData2_60$OutlierFraction,paired=T)
wilcox.test(outlierRandData2_40$OutlierFraction,outlierRandData2_60$OutlierFraction,paired=T)
wilcox.test(outlierRandData2_20$OutlierFraction,outlierRandData2_40$OutlierFraction,paired=T)

wilcox.test(outlierData1_20$OutlierFraction,outlierRandData1_20$OutlierFraction,paired=T)
wilcox.test(outlierData1_40$OutlierFraction,outlierRandData1_40$OutlierFraction)
wilcox.test(outlierData1_60$OutlierFraction,outlierRandData1_60$OutlierFraction)
wilcox.test(outlierData2_20$OutlierFraction,outlierRandData2_20$OutlierFraction)
wilcox.test(outlierData2_40$OutlierFraction,outlierRandData2_40$OutlierFraction)
wilcox.test(outlierData2_60$OutlierFraction,outlierRandData2_60$OutlierFraction)
wilcox.test(outlierData4_20$OutlierFraction,outlierRandData4_20$OutlierFraction)
wilcox.test(outlierData4_40$OutlierFraction,outlierRandData4_40$OutlierFraction)
wilcox.test(outlierData4_60$OutlierFraction,outlierRandData4_60$OutlierFraction)
wilcox.test(outlierData5_20$OutlierFraction,outlierRandData5_20$OutlierFraction)
wilcox.test(outlierData5_40$OutlierFraction,outlierRandData5_40$OutlierFraction)
wilcox.test(outlierData5_60$OutlierFraction,outlierRandData5_60$OutlierFraction)

####################################################
# Look at whether one outlier makes it more likely for there to be a second outlier

# Specific effects on related dimers to chosen dimer (e.g. AC on CC,TC,AA,AT)

seqsWithDimerOutliers <- sum(outlierData2_40$OutlierFraction>0)
seqOutlierFreq <- seqsWithDimerOutliers/length(outlierData2_40$OutlierFraction)
expectedMultipleOutliers <- seqOutlierFreq^2
actualMultipleOutliers <- sum(outlierData2_40$OutlierFraction>(1/9))
actualMultOutlierFreq <- actualMultipleOutliers/length(outlierData2_40$OutlierFraction)

coocur2_60 <- calculateOutlierCoocurrence(outlierData2_60,2)
coocurRand2_60 <- calculateOutlierCoocurrence(outlierRandData2_60,2)
coocurCor2_60 <- calculateOutlierCoocurrence(outlierData2_60,2,deviation="Cor")
coocurRandCor2_60 <- calculateOutlierCoocurrence(outlierRandData2_60,2,deviation="Cor")
coocurAbs2_60 <- calculateOutlierCoocurrence(outlierData2_60,2,deviation="Abs")
coocurAbsRand2_60 <- calculateOutlierCoocurrence(outlierRandData2_60,2,deviation="Abs")
coocurChisq2_60 <- calculateOutlierCoocurrence(outlierData2_60,2,chisq=T)
coocurChisqRand2_60 <- calculateOutlierCoocurrence(outlierRandData2_60,2,chisq=T)

write.csv(coocur2_60,paste(directory,"/outlierCoocur2_60.csv",sep=""))
write.csv(coocurRand2_60,paste(directory,"/outlierCoocurRand2_60.csv",sep=""))
write.csv(coocurCor2_60,paste(directory,"/outlierCoocurCor2_60.csv",sep=""))
write.csv(coocurRandCor2_60,paste(directory,"/outlierCoocurCorRand2_60.csv",sep=""))


binomFit2_60<-outlierBinomialFit(outlierData2_60,2)
binomRandFit2_60<-outlierBinomialFit(outlierRandData2_60,2)

plotBinomialDataAndFits(outlierData2_60,outlierRandData2_60,2)
plotBinomialDataAndFits(outlierData3_60,outlierRandData3_60,3)


ecdfData <- ecdf(outlierData2_60$OutlierFraction*9)
ecdfRandData <- ecdf(outlierRandData2_60$OutlierFraction*9)
x11()
plot(0:9,ecdfData(0:9))
points(0:9,pbinom(0:9,9,coef(binomFit2_60)["p"]),col=2)
x11()
plot(0:9,ecdfRandData(0:9)-c(0,ecdfRandData(0:8)),col=2)
lines(0:9,dbinom(0:9,9,coef(binomRandFit2_60)["p"]),col=2)
points(0:9,ecdfData(0:9)-c(0,ecdfData(0:8)))
lines(0:9,dbinom(0:9,9,coef(binomFit2_60)["p"]),col=1)
binom.test(2,9,0.05)

#############

outlierRandData1LTS_2 <- calculatePROutlierFraction(outlierRandData1_2,1)
outlierRandData2B8LTS_2 <- calculatePROutlierFraction(outlierRandData2B8_2,2)
outlierRandData3B8LTS_2 <- calculatePROutlierFraction(outlierRandData3B8_2,3)
outlierRandData4B8LTS_2 <- calculatePROutlierFraction(outlierRandData4B8_2,4)

outlierFractionByClass(outlierRandData1LTS,1,"LTS",randomSet=21,randomK=0,freq=T)
outlierFractionByClass(outlierRandData2B8LTS,2,"LTS",randomSet=21,randomK=1,freq=T)
outlierFractionByClass(outlierRandData3B8LTS,3,"LTS",randomSet=21,randomK=2,freq=T)
outlierFractionByClass(outlierRandData4B8LTS,4,"LTS",randomSet=21,randomK=3,freq=T)

outlierRandData2B8STL <- calculatePROutlierFraction(outlierRandData2B8STL,2)
outlierRandData3B8STL <- calculatePROutlierFraction(outlierRandData3B8STL,3)
outlierRandData4B8STL <- calculatePROutlierFraction(outlierRandData4B8STL,4)

testOutliersByClass(outlierData1LTS,outlierRandData1LTS,1,minLength=0)
testOutliersByClass(outlierData3B8LTS,outlierRandData3B8LTS,3,minLength=0)
testOutliersByClass(outlierData4B8LTS,outlierRandData4B8LTS,4,minLength=0)
testOutliersByClass(outlierData4B8LTS,outlierRandData4B8LTS,4,minLength=60)

avgOutlierFractionLTS <- c(mean(outlierData1LTS$OutlierFraction),mean(outlierData2B8LTS$OutlierFraction),mean(outlierData3B8LTS$OutlierFraction),mean(outlierData4B8LTS$OutlierFraction))
sdOutlierFractionLTS <- c(sd(outlierData1LTS$OutlierFraction),sd(outlierData2B8LTS$OutlierFraction),sd(outlierData3B8LTS$OutlierFraction),sd(outlierData4B8LTS$OutlierFraction))
semOutlierFractionLTS <- c(sd(outlierData1LTS$OutlierFraction/sqrt(length(outlierData1LTS$OutlierFraction))),sd(outlierData2B8LTS$OutlierFraction)/sqrt(length(outlierData2B8LTS$OutlierFraction)),sd(outlierData3B8LTS$OutlierFraction)/sqrt(length(outlierData3B8LTS$OutlierFraction)),sd(outlierData4B8LTS$OutlierFraction/sqrt(length(outlierData4B8LTS$OutlierFraction))))

avgRandOutlierFractionLTS <- c(mean(outlierRandData1LTS$OutlierFraction),mean(outlierRandData2B8LTS$OutlierFraction),mean(outlierRandData3B8LTS$OutlierFraction),mean(outlierRandData4B8LTS$OutlierFraction))
sdRandOutlierFractionLTS <- c(sd(outlierRandData1LTS$OutlierFraction),sd(outlierRandData2B8LTS$OutlierFraction),sd(outlierRandData3B8LTS$OutlierFraction),sd(outlierRandData4B8LTS$OutlierFraction))
semRandOutlierFractionLTS <- c(sd(outlierRandData1LTS$OutlierFraction/sqrt(length(outlierRandData1LTS$OutlierFraction))),sd(outlierRandData2B8LTS$OutlierFraction)/sqrt(length(outlierRandData2B8LTS$OutlierFraction)),sd(outlierRandData3B8LTS$OutlierFraction)/sqrt(length(outlierRandData3B8LTS$OutlierFraction)),sd(outlierRandData4B8LTS$OutlierFraction/sqrt(length(outlierRandData4B8LTS$OutlierFraction))))

kmerOutliers1ByClass <- c(Dendrite=kmerOutlierFractionsByClass(outlierData1LTS,1,arborType="Dendrite"),
                    ApicalDendrite=kmerOutlierFractionsByClass(outlierData1LTS,1,arborType="ApicalDendrite"),
                    Axon=kmerOutlierFractionsByClass(outlierData1LTS,1,arborType="Axon"))
kmerRandOutliers1ByClass <- c(Dendrite=kmerOutlierFractionsByClass(outlierRandData1LTS,1,arborType="Dendrite"),
                    ApicalDendrite=kmerOutlierFractionsByClass(outlierRandData1LTS,1,arborType="ApicalDendrite"),
                    Axon=kmerOutlierFractionsByClass(outlierRandData1LTS,1,arborType="Axon"))

summary1LTS<-outlierSummaryByClass(outlierData1LTS,1)
summary2B8LTS<-outlierSummaryByClass(outlierData2B8LTS,2)
summary3B8LTS<-outlierSummaryByClass(outlierData3B8LTS,3)
summary4B8LTS<-outlierSummaryByClass(outlierData4B8LTS,4)

###TODO###
# All axons
# All 
# Next is the harder part, whether a given sequence's k+1-mers stand out statistically
##########

# Axons
axonOutlierData <- list()
for (k in 1:4){
  axonOutlierData[[k]] <- getSubset(outlierData[[k]],arborType="Axon")
}
mean(axonOutlierData[[1]]$C)

# Dendrites
dendriteOutlierData <- list()
for (k in 1:4){
  dendriteOutlierData[[k]] <- getSubset(outlierData[[k]],arborType="Dendrite")
}
mean(dendriteOutlierData[[1]]$C)

# Apical Dendrites
apicalOutlierData <- list()
for (k in 1:4){
  apicalOutlierData[[k]] <- getSubset(outlierData[[k]],arborType="ApicalDendrite")
}
mean(apicalOutlierData[[1]]$C)

# Pyramidal axons

# Uniglomerular axons

# Cortical apical dendrites

# Hippocampal apical dendrites

####################################################
# Fix OutlierFractions
#for (k in 3:5){
#  numKmers <- length(getKmersForOutlierAnalysis(k,outlierData[[k]]))
#  outlierData[[k]]$OutlierFraction <- outlierData[[k]]$OutlierFraction*actualNumKmers[kPlus]/numKmers
#  outlierRandData[[k]]$OutlierFraction <- outlierRandData[[k]]$OutlierFraction*actualNumKmers[kPlus]/numKmers
#  for (i in 1:40){
#    nullHData[[k]][[i]]$OutlierFraction <- nullHData[[k]][[i]]$OutlierFraction*actualNumKmers[kPlus]/numKmers
#  }
#}
#for (k in 3:5){
#  numKmers <- length(getKmersForOutlierAnalysis(k,outlierData[[k]]))
#  outlierData[[k]]$OutlierFraction <- outlierData[[k]]$OutlierFraction*actualNumKmers[k]/actualNumKmers[kPlus]
#  outlierRandData[[k]]$OutlierFraction <- outlierRandData[[k]]$OutlierFraction*actualNumKmers[k]/actualNumKmers[kPlus]
#  for (i in 1:40){
#    nullHData[[k]][[i]]$OutlierFraction <- nullHData[[k]][[i]]$OutlierFraction*actualNumKmers[k]/actualNumKmers[kPlus]
#  }
#}
