source("C:/Documents and Settings/gillette/My Documents/My Dropbox/RCode/Utils.r")
kmerFreqDirectory <- "C:/Documents and Settings/gillette/My Documents/research/MotifAnalysis/RawKmerFreqs/";
#defaultDirectory <- "/Users/toddgillette/Dropbox/Motif Analysis/Data/";
defaultOrder <- "LTS"
defaultMethod <- 8
defaultThreshold <- "0.0"
defaultThreshType <- "Whole"

sources("RawKmerFreqsFunctions.r")

actualNumKmers <- c(1,9,25,68,183)

kmerFreqs <- list()
kmerFreqs[[1]] <- getKmerFreqs(1)
kmerFreqs[[2]] <- getKmerFreqs(2)
kmerFreqs[[3]] <- getKmerFreqs(3)
tmpKmerFreqs <- getKmerFreqs(3,travOrder="STL",sourceTraversal="STL")

# Randoms
randKmerFreqs <- list()
randKmerFreqs[[1]] <- getKmerFreqs(1,useRandomSet=21,useRandomK=0,method=8)
randKmerFreqs[[1]] <- cbind(randKmerFreqs[[1]],SeqLen=metaData[randKmerFreqs[[1]]$Sequence,"SeqLen"])
randKmerFreqs[[2]] <- getKmerFreqs(2,useRandomSet=21,useRandomK=1,method=8)
randKmerFreqs[[2]] <- cbind(randKmerFreqs[[2]],SeqLen=metaData[randKmerFreqs[[2]]$Sequence,"SeqLen"])

randB3_LTS3merFreqs <- getKmerFreqs(3,method=3,useRandomSets=20,useRandomK=2,travOrder="LTS",sourceTraversal="",threshold="0.0")
randB3_STL3merFreqs <- getKmerFreqs(3,method=3,useRandomSets=20,useRandomK=2,travOrder="STL",sourceTraversal="LTS",threshold="0.0")
colnames(randB3_STL3merFreqs) <- paste("s",colnames(randB3_STL3merFreqs),sep="")
randB8_LTS3merFreqs <- getKmerFreqs(3,method=8,useRandomSets=40,useRandomK=2,travOrder="LTS",sourceTraversal="LTS",threshold="0.0")[,-1]
#randB8_STL3merFreqs <- getKmerFreqs(3,method=8,useRandomSets=40,useRandomK=2,travOrder="STL",sourceTraversal="STL",threshold="0.0")[,-1]
randB8_STL3merFreqs <- getKmerFreqs(3,method=8,useRandomSets=40,useRandomK=2,travOrder="STL",sourceTraversal="LTS",threshold="0.0")[,-1]
colnames(randB8_STL3merFreqs) <- paste("s",colnames(randB8_STL3merFreqs),sep="")

randB8_LTS3merFreqsSet2 <- getKmerFreqs(3,method=8,useRandomSet=2,useRandomSets=40,useRandomK=2,travOrder="LTS",sourceTraversal="LTS",threshold="0.0")
randB8_STL3merFreqsSet2 <- getKmerFreqs(3,method=8,useRandomSet=2,useRandomSets=40,useRandomK=2,travOrder="STL",sourceTraversal="LTS",threshold="0.0")
colnames(randB8_STL3merFreqsSet2) <- paste("s",colnames(randB8_STL3merFreqsSet2),sep="")

randB8_LTS3merFreqsSet4 <- getKmerFreqs(3,method=8,useRandomSet=4,useRandomSets=40,useRandomK=2,travOrder="LTS",sourceTraversal="LTS",threshold="0.0")
randB8_STL3merFreqsSet4 <- getKmerFreqs(3,method=8,useRandomSet=4,useRandomSets=40,useRandomK=2,travOrder="STL",sourceTraversal="LTS",threshold="0.0")
colnames(randB8_STL3merFreqsSet4) <- paste("s",colnames(randB8_STL3merFreqsSet4),sep="")

randB8_LTS3merFreqsSet5 <- getKmerFreqs(3,method=8,useRandomSet=5,useRandomSets=40,useRandomK=2,travOrder="LTS",sourceTraversal="LTS",threshold="0.0")
randB8_STL3merFreqsSet5 <- getKmerFreqs(3,method=8,useRandomSet=5,useRandomSets=40,useRandomK=2,travOrder="STL",sourceTraversal="LTS",threshold="0.0")
colnames(randB8_STL3merFreqsSet5) <- paste("s",colnames(randB8_STL3merFreqsSet5),sep="")

randB8_LTS3merFreqsSet6 <- getKmerFreqs(3,method=8,useRandomSet=6,useRandomSets=40,useRandomK=2,travOrder="LTS",sourceTraversal="LTS",threshold="0.0")
randB8_STL3merFreqsSet6 <- getKmerFreqs(3,method=8,useRandomSet=6,useRandomSets=40,useRandomK=2,travOrder="STL",sourceTraversal="LTS",threshold="0.0")
colnames(randB8_STL3merFreqsSet6) <- paste("s",colnames(randB8_STL3merFreqsSet6),sep="")

randB8_LTS3merFreqs <- randB8_LTS3merFreqsSet6
randB8_STL3merFreqs <- randB8_STL3merFreqsSet6
  
randKmerSeqs <- intersect(rownames(randB3_LTS3merFreqs),rownames(randB3_STL3merFreqs))
randKmerSeqs <- intersect(randKmerSeqs,rownames(randB8_LTS3merFreqs))
randKmerSeqs <- intersect(randKmerSeqs,rownames(randB8_STL3merFreqs))

#randKmerSeqs <- intersect(rownames(randB8_LTS3merFreqs),rownames(randB8_STL3merFreqs))

randB3_3merFreqs <- cbind(randB3_LTS3merFreqs[randKmerSeqs,],randB3_STL3merFreqs[randKmerSeqs,])
randB3_3merFreqs <- randB3_3merFreqs[,!grepl("ATT",colnames(randB3_3merFreqs))]
randB3_3merFreqs <- randB3_3merFreqs[,!grepl("s[ACT]C[ACT]",colnames(randB3_3merFreqs))]

randB8_3merFreqs <- cbind(randB8_LTS3merFreqs[randKmerSeqs,],randB8_STL3merFreqs[randKmerSeqs,])
randB8_3merFreqs <- randB8_3merFreqs[,!grepl("ATT",colnames(randB8_3merFreqs))]
randB8_3merFreqs <- randB8_3merFreqs[,!grepl("s[ACT]C[ACT]",colnames(randB8_3merFreqs))]

randB8_3merFreqsSet5 <- cbind(randB8_LTS3merFreqsSet5[randKmerSeqs,],randB8_STL3merFreqsSet5[randKmerSeqs,])
randB8_3merFreqsSet5 <- randB8_3merFreqsSet5[,!grepl("ATT",colnames(randB8_3merFreqsSet5))]
randB8_3merFreqsSet5 <- randB8_3merFreqsSet5[,!grepl("s[ACT]C[ACT]",colnames(randB8_3merFreqsSet5))]

# Comparing uniform distribution vs fast generation methods
boxplot(randB3_3merFreqs,boxwex=.25,at=1:length(randB8_3merFreqs)-.3,las=3)
boxplot(randB8_3merFreqs,boxwex=.25,at=1:length(randB8_3merFreqs)+.05,add=T,xaxt='n')

randB38_3merFreqDiff <- as.data.frame(as.matrix(randB8_3merFreqs)-as.matrix(randB3_3merFreqs))
title <- "Dimer constrained Fast Generation (Set6) minus\nTrue Uniform trimer frequencies"
boxplot(randB38_3merFreqDiff,las=3,main=title,ylim=c(-.02,.02))
barplot(apply(randB38_3merFreqDiff,2,mean),las=3)

distributionComparison(list(randB38_3merFreqDiff),las=3,title=title,error="SEM",ylim=c(-.003,.003))
distributionComparison(list(Uniform=randB3_3merFreqs,FastGen=randB8_3merFreqs),las=3,title=title,plotType="box")

randB8_2Sets_3merFreqDiff <- as.data.frame(as.matrix(randB8_3merFreqs)-as.matrix(randB8_3merFreqsSet5))
title <- "Dimer constrained Fast-Gen Set6 minus\nFast-Gen Set5 trimer frequencies"
boxplot(randB8_2Sets_3merFreqDiff,las=3,main=title,ylim=c(-.02,.02))


# Same analyses, but now as a function of sequence length (one trimer at a time)
plot(masterMetaData[rownames(randB38_3merFreqDiff),"SeqLen"],randB38_3merFreqDiff$AAA)
plotOverLengths(randB38_3merFreqDiff,column="ACC")

##########################
# Constraint 3, k=4 baseline comparison between uniform and fast-gen
randB3_LTS4merFreqs <- getKmerFreqs(4,method=3,useRandomSets=20,useRandomK=3,travOrder="LTS",sourceTraversal="LTS",threshold="0.0")
randB3_STL4merFreqs <- getKmerFreqs(4,method=3,useRandomSets=20,useRandomK=3,travOrder="STL",sourceTraversal="LTS",threshold="0.0")
#randB3_STL4merFreqs <- getKmerFreqs(4,method=3,useRandomSets=20,useRandomK=3,travOrder="STL",sourceTraversal="LTS",threshold="0.0")
colnames(randB3_STL4merFreqs) <- paste("s",colnames(randB3_STL4merFreqs),sep="")

randB8_LTS4merFreqsSet2 <- getKmerFreqs(4,method=8,useRandomSet=2,useRandomSets=40,useRandomK=3,travOrder="LTS",sourceTraversal="LTS",threshold="0.0")
randB8_STL4merFreqsSet2 <- getKmerFreqs(4,method=8,useRandomSet=2,useRandomSets=40,useRandomK=3,travOrder="STL",sourceTraversal="STL",threshold="0.0")
colnames(randB8_STL4merFreqsSet2) <- paste("s",colnames(randB8_STL4merFreqsSet2),sep="")

randB8_LTS4merFreqsSet7 <- getKmerFreqs(4,method=8,useRandomSet=7,useRandomSets=40,useRandomK=3,travOrder="LTS",sourceTraversal="LTS",threshold="0.0")
randB8_STL4merFreqsSet7 <- getKmerFreqs(4,method=8,useRandomSet=7,useRandomSets=40,useRandomK=3,travOrder="STL",sourceTraversal="STL",threshold="0.0")
colnames(randB8_STL4merFreqsSet7) <- paste("s",colnames(randB8_STL4merFreqsSet7),sep="")
randB8LTS_STL4merFreqsSet7 <- getKmerFreqs(4,method=8,useRandomSet=7,useRandomSets=40,useRandomK=3,travOrder="STL",sourceTraversal="LTS",threshold="0.0")
colnames(randB8LTS_STL4merFreqsSet7) <- paste("s",colnames(randB8LTS_STL4merFreqsSet7),sep="")

randB8_LTS4merFreqsSet8 <- getKmerFreqs(4,method=8,useRandomSet=8,useRandomSets=40,useRandomK=3,travOrder="LTS",sourceTraversal="LTS",threshold="0.0")
randB8_STL4merFreqsSet8 <- getKmerFreqs(4,method=8,useRandomSet=8,useRandomSets=40,useRandomK=3,travOrder="STL",sourceTraversal="STL",threshold="0.0")
colnames(randB8_STL4merFreqsSet8) <- paste("s",colnames(randB8_STL4merFreqsSet8),sep="")
randB8LTS_STL4merFreqsSet8 <- getKmerFreqs(4,method=8,useRandomSet=8,useRandomSets=40,useRandomK=3,travOrder="STL",sourceTraversal="LTS",threshold="0.0")
colnames(randB8LTS_STL4merFreqsSet8) <- paste("s",colnames(randB8LTS_STL4merFreqsSet8),sep="")

randB8_LTS4merFreqsSet9 <- getKmerFreqs(4,method=8,useRandomSet=9,useRandomSets=40,useRandomK=3,travOrder="LTS",sourceTraversal="LTS",threshold="0.0")
randB8LTS_STL4merFreqsSet9 <- getKmerFreqs(4,method=8,useRandomSet=9,useRandomSets=40,useRandomK=3,travOrder="STL",sourceTraversal="LTS",threshold="0.0")
colnames(randB8LTS_STL4merFreqsSet9) <- paste("s",colnames(randB8LTS_STL4merFreqsSet9),sep="")

randB8_LTS4merFreqsSet10 <- getKmerFreqs(4,method=8,useRandomSet=10,useRandomSets=40,useRandomK=3,travOrder="LTS",sourceTraversal="LTS",threshold="0.0")
randB8LTS_STL4merFreqsSet10 <- getKmerFreqs(4,method=8,useRandomSet=10,useRandomSets=40,useRandomK=3,travOrder="STL",sourceTraversal="LTS",threshold="0.0")
colnames(randB8LTS_STL4merFreqsSet10) <- paste("s",colnames(randB8LTS_STL4merFreqsSet10),sep="")

randB8_LTS4merFreqsSet11 <- getKmerFreqs(4,method=8,useRandomSet=11,useRandomSets=40,useRandomK=3,travOrder="LTS",sourceTraversal="LTS",threshold="0.0")
randB8LTS_STL4merFreqsSet11 <- getKmerFreqs(4,method=8,useRandomSet=11,useRandomSets=40,useRandomK=3,travOrder="STL",sourceTraversal="LTS",threshold="0.0")
colnames(randB8LTS_STL4merFreqsSet11) <- paste("s",colnames(randB8LTS_STL4merFreqsSet11),sep="")

randB8_LTS4merFreqs <- randB8_LTS4merFreqsSet11
randB8_STL4merFreqs <- randB8LTS_STL4merFreqsSet11

randKmerSeqs <- intersect(rownames(randB3_LTS4merFreqs),rownames(randB3_STL4merFreqs))
randKmerSeqs <- intersect(randKmerSeqs,rownames(randB8_LTS4merFreqs))
randKmerSeqs <- intersect(randKmerSeqs,rownames(randB8_STL4merFreqs))

#randKmerSeqs <- intersect(rownames(randB8_LTS3merFreqs),rownames(randB8_STL3merFreqs))

randB3_4merFreqs <- cbind(randB3_LTS4merFreqs[randKmerSeqs,],randB3_STL4merFreqs[randKmerSeqs,])
randB3_4merFreqs <- randB3_4merFreqs[,!grepl("s[ACT]C+[ACT]",colnames(randB3_4merFreqs))]

randB8_4merFreqs <- cbind(randB8_LTS4merFreqs[randKmerSeqs,],randB8_STL4merFreqs[randKmerSeqs,])
randB8_4merFreqs <- randB8_4merFreqs[,!grepl("s[ACT]C+[ACT]",colnames(randB8_4merFreqs))]

# Comparing uniform distribution vs fast generation methods
boxplot(randB3_4merFreqs,boxwex=.25,at=1:length(randB8_4merFreqs)-.3,las=3)
boxplot(randB8_4merFreqs,boxwex=.25,at=1:length(randB8_4merFreqs)+.05,add=T,xaxt='n')

randB38_4merFreqDiff <- as.data.frame(as.matrix(randB8_4merFreqs)-as.matrix(randB3_4merFreqs))
randB38_4merFreqDiffMeans <- apply(randB38_4merFreqDiff,2,mean)
biggestMeans <- colnames(randB38_4merFreqDiff)[abs(randB38_4merFreqDiffMeans) > median(abs(randB38_4merFreqDiffMeans))]
title <- "LTS-Trimer constrained Fast Generation (Set11) minus\nTrue Uniform tetramer frequencies"
boxplot(randB38_4merFreqDiff,las=3,main=title,ylim=c(-.02,.02))
barplot(apply(randB38_4merFreqDiff[,biggestMeans],2,mean),las=3)

distributionComparison(list(randB38_4merFreqDiff),las=3,title=title,error="SEM",ylim=c(-.005,.005))
distributionComparison(list(randB38_4merFreqDiff[,biggestMeans]),las=3,title=title,error="SEM",ylim=c(-.005,.005))

distributionComparison(list(Uniform=randB3_4merFreqs,FastGen=randB8_4merFreqs),las=3,title=title,plotType="box")

randB8_LTS4merFreqsSet9$CTC <- randB8_LTS4merFreqsSet9$ACTC+randB8_LTS4merFreqsSet9$CCTC+randB8_LTS4merFreqsSet9$TCTC
randB8_LTS4merFreqsSet9$CTT <- randB8_LTS4merFreqsSet9$ACTT+randB8_LTS4merFreqsSet9$CCTT+randB8_LTS4merFreqsSet9$TCTT
seqsCTC <- randKmerSeqs[randB8_LTS4merFreqsSet9[randKmerSeqs,"CTC"]>0]
seqsCTT <- randKmerSeqs[randB8_LTS4merFreqsSet9[randKmerSeqs,"CTT"]>0]
usedSeqs <- intersect(seqsCTC,seqsCTT)

hist(randB8_LTS4merFreqsSet9[usedSeqs,"ACTC"]/(randB8_LTS4merFreqsSet9[usedSeqs,"ACTT"]+randB8_LTS4merFreqsSet9[usedSeqs,"ACTC"]),breaks=30)
hist(randB3_4merFreqs[usedSeqs,"ACTC"]/(randB3_4merFreqs[usedSeqs,"ACTT"]+randB3_4merFreqs[usedSeqs,"ACTC"]),breaks=30)
usedSeqs2 <- intersect(usedSeqs,rownames(randB3_4merFreqs)[randB3_4merFreqs$ACTT+randB3_4merFreqs$ACTC>0])
hist(randB3_4merFreqs[usedSeqs2,"ACTC"]/(randB3_4merFreqs[usedSeqs2,"ACTT"]+randB3_4merFreqs[usedSeqs2,"ACTC"]),breaks=30)
mean(randB3_4merFreqs[usedSeqs2,"ACTC"]/(randB3_4merFreqs[usedSeqs2,"ACTT"]+randB3_4merFreqs[usedSeqs2,"ACTC"]))


hist(randB8_LTS4merFreqsSet9[usedSeqs,"ACTC"]/randB8_LTS4merFreqsSet9[usedSeqs,"CTC"],breaks=30)
hist(randB8_LTS4merFreqsSet10[usedSeqs,"ACTC"]/randB8_LTS4merFreqsSet9[usedSeqs,"CTC"],breaks=30)
hist(randB8_LTS4merFreqsSet11[usedSeqs,"ACTC"]/randB8_LTS4merFreqsSet9[usedSeqs,"CTC"],breaks=30)
hist(randB3_4merFreqs[usedSeqs,"ACTC"]/randB8_LTS4merFreqsSet9[usedSeqs,"CTC"],breaks=30)

hist(randB8_LTS4merFreqsSet9[usedSeqs,"ACTT"]/randB8_LTS4merFreqsSet9[usedSeqs,"CTT"],breaks=30)
hist(randB3_4merFreqs[usedSeqs,"ACTT"]/randB8_LTS4merFreqsSet9[usedSeqs,"CTT"],breaks=30)

plot(randB8_LTS4merFreqsSet9[usedSeqs,"CTT"]/(randB8_LTS4merFreqsSet9[usedSeqs,"CTT"]+randB8_LTS4merFreqsSet9[usedSeqs,"CTC"]),randB8_LTS4merFreqsSet9[usedSeqs,"ACTT"]/(randB8_LTS4merFreqsSet9[usedSeqs,"ACTT"]+randB8_LTS4merFreqsSet9[usedSeqs,"ACTC"]))

rangedSeqs <- usedSeqs[abs(randB8_LTS4merFreqsSet9[usedSeqs,"CTT"]/(randB8_LTS4merFreqsSet9[usedSeqs,"CTT"]+randB8_LTS4merFreqsSet9[usedSeqs,"CTC"])-.2)<.07]
hist(randB8_LTS4merFreqsSet9[rangedSeqs,"ACTT"]/(randB8_LTS4merFreqsSet9[rangedSeqs,"ACTT"]+randB8_LTS4merFreqsSet9[rangedSeqs,"ACTC"]),breaks=30)

plot(randB8_LTS4merFreqsSet9[usedSeqs,"CTT"]/(randB8_LTS4merFreqsSet9[usedSeqs,"CTT"]+randB8_LTS4merFreqsSet9[usedSeqs,"CTC"]),randB8_LTS4merFreqsSet9[usedSeqs,"ACTT"])

#########################################################################

# Terminal growth
termGrowCFreqs <- getKmerFreqs(1,useRandomSet=9,useRandomK=0,method=2)

# Terminal & Interstitial growth
interstGrowCFreqs <- getKmerFreqs(1,useRandomSet=1,useRandomK=0,method=9)

# Plot %C for different arbor types
axonCFreq <- getSubset(kmerFreqs[[1]],arborType="Axon")
axonCFreq <- cbind(axonCFreq,SeqLen=metaData[axonCFreq$Sequence,"SeqLen"])
dendriteCFreq <- getSubset(kmerFreqs[[1]],arborType="Dendrite")
dendriteCFreq <- cbind(dendriteCFreq,SeqLen=metaData[dendriteCFreq$Sequence,"SeqLen"])
apicalCFreq <- getSubset(kmerFreqs[[1]],arborType="ApicalDendrite")
apicalCFreq <- cbind(apicalCFreq,SeqLen=metaData[apicalCFreq$Sequence,"SeqLen"])
x11()
par(mar=c(3,2,1,1),mfrow=c(3,1))
hist(axonCFreq$C,main="Axon",breaks=(0:20)/20)
hist(apicalCFreq$C,main="Apical Dendrite",breaks=(0:20)/20)
hist(dendriteCFreq$C,main="Dendrite/Basal Dendrite",breaks=(0:20)/20)

x11()
plot(metaData[axonCFreq$Sequence,"SeqLen"],axonCFreq$C)

# Plot separately
plotOverLengths(axonCPR,"C",minValues=10,plotXRange=T,yRangeType="Range",title="Axon C Percentile Ranks")
plotOverLengths(dendriteCPR,"C",minValues=10,plotXRange=T,yRangeType="Range",title="Dendrite C Percentile Ranks")
plotOverLengths(apicalCPR,"C",minValues=10,plotXRange=T,yRangeType="Range",title="Apical Dendrite C Percentile Ranks")

# Plot together
plotOverLengths(axonCPR,"C",minValues=10,plotXRange=T,yRangeType="SEM",title="Arbor C Percentile Ranks",new=T,col=2,xlim=c(0,700),ylim=c(.15,1))
plotOverLengths(apicalCPR,"C",minValues=10,plotXRange=T,yRangeType="SEM",new=F,col=3)
plotOverLengths(dendriteCPR,"C",minValues=10,plotXRange=T,yRangeType="SEM",new=F,col=4)
legend(x=550,y=.4,legend=c("Axon","Apical","Dendrite"),col=c(2,3,4),pch=1)

plotOverLengths(axonCPR,"C",minValues=10,plotXRange=T,yRangeType="SEM",title="Arbor C Percentile Ranks",new=T,col=2,xlim=c(0,200),ylim=c(.15,1))
plotOverLengths(apicalCPR,"C",minValues=10,plotXRange=T,yRangeType="SEM",new=F,col=3)
plotOverLengths(dendriteCPR,"C",minValues=10,plotXRange=T,yRangeType="SEM",new=F,col=4)
legend(x=150,y=.4,legend=c("Axon","Apical","Dendrite"),col=c(2,3,4),pch=1)

# Plot C frequencies separately
plotOverLengths(axonCFreq,"C",minValues=10,plotXRange=T,yRangeType="None",title="Axon C Frequencies")
plotOverLengths(dendriteCFreq,"C",minValues=10,plotXRange=T,yRangeType="None",title="Dendrite C Frequencies")
plotOverLengths(apicalCFreq,"C",minValues=10,plotXRange=T,yRangeType="None",title="Apical Dendrite C Frequencies")

# Plot C frequencies together
plotOverLengths(axonCFreq,"C",minValues=10,plotXRange=T,yRangeType="SEM",title="Arbor C Frequencies",new=T,fcol=2,fylim=c(.25,.55))
plotOverLengths(apicalCFreq,"C",minValues=10,plotXRange=T,yRangeType="SEM",new=F,fcol=3)
plotOverLengths(dendriteCFreq,"C",minValues=10,plotXRange=T,yRangeType="SEM",new=F,fcol=4)
legend(x=550,y=.35,legend=c("Axon","Apical","Dendrite"),col=c(2,3,4),pch=1)

plotOverLengths(axonCFreq,"C",minValues=10,plotXRange=T,yRangeType="SEM",title="Arbor C Frequencies",new=T,fcol=2,fxlim=c(0,200),fylim=c(.25,.55),plotXHistogram=T)
plotOverLengths(apicalCFreq,"C",minValues=10,plotXRange=T,yRangeType="SEM",new=F,fcol=3,plotXHistogram=T)
plotOverLengths(dendriteCFreq,"C",minValues=10,plotXRange=T,yRangeType="SEM",new=F,fcol=4,plotXHistogram=T)
legend(x=150,y=.35,legend=c("Axon","Apical","Dendrite"),fcol=c(2,3,4),pch=1)

# Plot C frequency smooths: by arbor type and with randoms
fxlim <- c(0,500)
fylim <- c(.25,.55)
plotSmooths(axonCFreq,"C",minValues=10,confidence=.95,title="Arbor C Frequencies",new=T,fcol="cyan2",fxlim=fxlim,fylim=fylim,plotXHistogram=T,lwd=2)
plotSmooths(apicalCFreq,"C",minValues=10,confidence=.95,new=F,fcol="brown3",plotXHistogram=T,lwd=2,fylim=fylim)
plotSmooths(dendriteCFreq,"C",minValues=10,confidence=.95,new=F,fcol="cornflowerblue",plotXHistogram=T,lwd=2,fylim=fylim)
plotSmooths(randKmerFreqs[[1]],"C",minValues=10,confidence=.95,new=F,fcol=1,lwd=2,fylim=fylim)
#legend(x=125,y=.35,legend=c("Axon","Apical","Dendrite","Uniform Randoms"),col=c("cyan2","brown3","cornflowerblue",1),pch=1)
#text(x=50,y=.265,labels="Histogram of sequence lengths",pos=4)
text(x=100,y=.265,labels="Histogram of sequence lengths",pos=4)
plotSmooths(termGrowCFreqs,"C",minValues=10,new=F,confidence=.95,fcol="gray40",lwd=2,fylim=fylim)
plotSmooths(interstGrowCFreqs,"C",minValues=10,new=F,confidence=.95,fcol="gray60",lwd=2,fylim=fylim)
#legend(x=110,y=.37,legend=c("Axon","Apical","Dendrite","Interst. Growth Random","Uniform Random","Term. Growth Random"),col=c("cyan2","brown3","cornflowerblue","gray60",1,"gray40"),lty=1,lwd=2,bg="white")
legend(x=250,y=.37,legend=c("Axon","Apical","Dendrite","Interst. Growth Random","Uniform Random","Term. Growth Random"),col=c("cyan2","brown3","cornflowerblue","gray60",1,"gray40"),lty=1,lwd=2,bg="white")

plotSmooths(axonCFreq,"C",minValues=10,title="Arbor C Frequencies",new=F,fcol="cyan2",fylim=fylim,lwd=2)
plotSmooths(apicalCFreq,"C",minValues=10,new=F,fcol="brown3",lwd=2,fylim=fylim)
plotSmooths(dendriteCFreq,"C",minValues=10,new=F,fcol="cornflowerblue",lwd=2,fylim=fylim)
plotSmooths(randKmerFreqs[[1]],"C",minValues=10,new=F,fcol=1,lwd=2,fylim=fylim)
plotSmooths(termGrowCFreqs,"C",minValues=10,new=F,fcol="gray50",lwd=2,fylim=fylim)
plotSmooths(interstGrowCFreqs,"C",minValues=10,new=F,fcol="gray80",lwd=2,fylim=fylim)

# Dimer frequencies over tree size
# Terminal growth
termGrowDimerFreqs <- getKmerFreqs(2,useRandomSet=9,useRandomK=0,method=2)
# Terminal & Interstitial growth
interstGrowDimerFreqs <- getKmerFreqs(2,useRandomSet=1,useRandomK=0,method=9)
# Plot %dimer for different arbor types
axonDimerFreq <- getSubset(kmerFreqs[[2]],arborType="Axon")
axonDimerFreq <- cbind(axonDimerFreq,SeqLen=metaData[axonDimerFreq$Sequence,"SeqLen"])
dendriteDimerFreq <- getSubset(kmerFreqs[[2]],arborType="Dendrite")
dendriteDimerFreq <- cbind(dendriteDimerFreq,SeqLen=metaData[dendriteDimerFreq$Sequence,"SeqLen"])
apicalDimerFreq <- getSubset(kmerFreqs[[2]],arborType="ApicalDendrite")
apicalDimerFreq <- cbind(apicalDimerFreq,SeqLen=metaData[apicalDimerFreq$Sequence,"SeqLen"])

plotSmooths(axonDimerFreq,"CT",minValues=10,title="Arbor CT Frequencies",new=T,fcol="cyan2",fylim=fylim,lwd=2)
plotSmooths(apicalDimerFreq,"CT",minValues=10,new=F,fcol="brown3",lwd=2,fylim=fylim)
plotSmooths(dendriteDimerFreq,"CT",minValues=10,new=F,fcol="cornflowerblue",lwd=2,fylim=fylim)
#plotSmooths(randKmerFreqs[[1]],"CT",minValues=10,new=F,fcol=1,lwd=2,fylim=fylim)
plotSmooths(termGrowDimerFreqs,"CT",minValues=10,new=F,fcol="gray50",lwd=2,fylim=fylim)

# C frequency smooths: Axon subclasses
pcAxonCFreq <- getSubset(kmerFreqs[[1]],arborType="Axon",cellType="Pyramidal cell")
interAxonCFreq <- getSubset(kmerFreqs[[1]],arborType="Axon",cellType="Interneuron")
upnAxonCFreq <- getSubset(kmerFreqs[[1]],arborType="Axon",cellType="Uniglomerular projection neuron")
cercalAxonCFreq <- getSubset(kmerFreqs[[1]],arborType="Axon",brainRegion="Cercal sensory system")
fxlim <- c(0,500)
fylim <- c(.25,.75)
plotSmooths(getSubset(kmerFreqs[[1]],arborType="Axon"),"C",minValues=10,confidence=.95,title="Arbor C Frequencies",new=T,fcol=1,fxlim=fxlim,fylim=fylim,plotXHistogram=T,lwd=2)
plotSmooths(pcAxonCFreq,"C",minValues=10,confidence=.95,new=F,fcol=2,plotXHistogram=T,lwd=2,fylim=fylim)
plotSmooths(interAxonCFreq,"C",minValues=10,confidence=.95,new=F,fcol=3,plotXHistogram=T,lwd=2,fylim=fylim)
plotSmooths(upnAxonCFreq,"C",minValues=10,confidence=.95,new=F,fcol=4,plotXHistogram=T,lwd=2,fylim=fylim)
plotSmooths(cercalAxonCFreq,"C",minValues=10,confidence=.95,new=F,fcol=5,plotXHistogram=T,lwd=2,fylim=fylim)
axonText <- paste("All Axons (N=",nrow(axonCFreq),")",sep="")
pcText <- paste("Pyramidal Cell (N=",nrow(pcAxonCFreq),")",sep="")
interText <- paste("Interneuron (N=",nrow(interAxonCFreq),")",sep="")
upnText <- paste("Drosophila Olfactory Bulb (N=",nrow(upnAxonCFreq),")",sep="")
cercalText <- paste("Cercal Sensory (N=",nrow(cercalAxonCFreq),")",sep="")
legend(x=200,y=.4,legend=c(axonText,pcText,interText,upnText,cercalText),col=c(1,2,3,4,5),lty=1,lwd=2,bg="white")
#text(x=50,y=.265,labels="Histogram of sequence lengths",pos=4)

# C frequency smooths: Dendrite subclasses
cortPyrDendCFreq <- getSubset(kmerFreqs[[1]],arborType="Dendrite",cellType="Pyramidal cell",brainRegion="Cerebral cortex")
hcPyrDendCFreq <- getSubset(kmerFreqs[[1]],arborType="Dendrite",cellType="Pyramidal cell",brainRegion="Hippocampus")
granuleDendCFreq <- getSubset(kmerFreqs[[1]],arborType="Dendrite",cellType="Granule cell",brainRegion="Hippocampus")
aspinyDendCFreq <- getSubset(kmerFreqs[[1]],arborType="Dendrite",cellType="Large aspiny cell")
motoDendCFreq <- getSubset(kmerFreqs[[1]],arborType="Dendrite",cellType="Motoneuron")
interDendCFreq <- getSubset(kmerFreqs[[1]],arborType="Dendrite",cellType="Interneuron")
medSpinyDendCFreq <- getSubset(kmerFreqs[[1]],arborType="Dendrite",cellType="Medium spiny cell")
retGangDendCFreq <- getSubset(kmerFreqs[[1]],arborType="Dendrite",cellType="Ganglion cell",brainRegion="Retina")
fxlim <- c(0,300)
fylim <- c(.2,.65)
conf <- 0
#plotSmooths(dendriteCFreq,"C",minValues=10,confidence=.95,title="Dendrite C Frequencies",new=T,fcol=1,fxlim=fxlim,fylim=fylim,plotXHistogram=F,lwd=2)
#plotSmooths(interDendCFreq,"C",minValues=10,confidence=.95,new=F,fcol=2,plotXHistogram=T,lwd=2,fylim=fylim)
plotSmooths(interDendCFreq,"C",minValues=10,confidence=conf,title="Dendrite C Frequencies",fcol=2,plotXHistogram=T,lwd=2,fxlim=fxlim,fylim=fylim,new=T)
plotSmooths(cortPyrDendCFreq,"C",minValues=10,confidence=conf,new=F,fcol=3,plotXHistogram=T,lwd=2,fylim=fylim)
plotSmooths(hcPyrDendCFreq,"C",minValues=10,confidence=conf,new=F,fcol=4,plotXHistogram=T,lwd=2,fylim=fylim)
plotSmooths(retGangDendCFreq,"C",minValues=10,confidence=conf,new=F,fcol=5,plotXHistogram=T,lwd=2,fylim=fylim)
plotSmooths(medSpinyDendCFreq,"C",minValues=10,new=F,fcol=6,plotXHistogram=F,lwd=2,fylim=fylim)
plotSmooths(motoDendCFreq,"C",minValues=10,new=F,fcol=7,plotXHistogram=F,lwd=2,fylim=fylim)
#plotSmooths(granuleDendCFreq,"C",minValues=10,new=F,fcol=5,plotXHistogram=F,lwd=2,fylim=fylim)
#plotSmooths(aspinyDendCFreq,"C",minValues=10,new=F,fcol=6,plotXHistogram=F,lwd=2,fylim=fylim)
dendText <- paste("All Dendrites (N=",nrow(dendriteCFreq),")",sep="")
interText <- paste("Interneuron (N=",nrow(interDendCFreq),")",sep="")
cortPyrText <- paste("Cortical Pyramidal (N=",nrow(cortPyrDendCFreq),")",sep="")
hcPyrText <- paste("Hippcampal Pyramidal (N=",nrow(hcPyrDendCFreq),")",sep="")
granuleText <- paste("DG Granule (N=",nrow(granuleDendCFreq),")",sep="")
aspinyText <- paste("Large Aspiny (N=",nrow(aspinyDendCFreq),")",sep="")
motoText <- paste("Motoneuron (N=",nrow(motoDendCFreq),")",sep="")
medSpinyText <- paste("Medium Spiny (N=",nrow(medSpinyDendCFreq),")",sep="")
retGangText <- paste("Retinal Ganglion (N=",nrow(retGangDendCFreq),")",sep="")
#legend(x=170,y=.37,legend=c(dendText,interText,cortPyrText,hcPyrText,medSpinyText,retGangText,motoText),col=c(1,2,3,4,5,6,7),lty=1,lwd=2,bg="white")
legend(x=125,y=.32,legend=c(interText,cortPyrText,hcPyrText,medSpinyText,retGangText,motoText),col=c(2,3,4,5,6,7),lty=1,lwd=2,bg="white")
#legend(x=200,y=.4,legend=c(dendText,interText,cortPyrText,hcPyrText,granuleText,aspinyText,motoText,medSpinyText,retGangText),col=c(1,2,3,4,5,6,7,8,9),lty=1,lwd=2,bg="white")
#text(x=50,y=.265,labels="Histogram of sequence lengths",pos=4)

# C frequency smooths: Apical subclasses
cortApicCFreq <- getSubset(kmerFreqs[[1]],arborType="ApicalDendrite",brainRegion="Cerebral cortex")
hcApicCFreq <- getSubset(kmerFreqs[[1]],arborType="ApicalDendrite",brainRegion="Hippocampus")
apicText <- paste("All Apical Dendrites (N=",nrow(apicalCFreq),")",sep="")
cortText <- paste("Cortical (N=",nrow(cortApicCFreq),")",sep="")
hcText <- paste("Hippocampal (N=",nrow(hcApicCFreq),")",sep="")
fxlim <- c(0,200)
fylim <- c(.265,.65)
plotSmooths(apicalCFreq,"C",minValues=10,confidence=.95,title="Apical Dendrite C Frequencies",new=T,fcol=1,fxlim=fxlim,fylim=fylim,plotXHistogram=T,lwd=2)
plotSmooths(cortApicCFreq,"C",minValues=10,confidence=.95,new=F,fcol=2,plotXHistogram=T,lwd=2,fylim=fylim)
plotSmooths(hcApicCFreq,"C",minValues=10,confidence=.95,new=F,fcol=3,plotXHistogram=T,lwd=2,fylim=fylim)
legend(x=80,y=.38,legend=c(apicText,cortText,hcText),col=c(1,2,3),lty=1,lwd=2,bg="white")
text(x=85,y=.29,labels="Histogram of sequence lengths",pos=4)

rand150To200 <- subset(randKmerFreqs[[1]],SeqLen>150&SeqLen<200)
rand50To100 <- subset(randKmerFreqs[[1]],SeqLen>50&SeqLen<100)
var(rand150To200$C)
var(rand50To100$C)
x11()

# Plot randoms
plotOverLengths(randKmerFreqs[[1]],"C",minValues=10,plotXRange=T,yRangeType="SEM",title="Random C Frequencies",new=T,fcol=1,fylim=c(.25,.55))
plotOverLengths(randKmerFreqs[[1]],"C",minValues=10,plotXRange=T,yRangeType="SEM",title="Random C Frequencies",new=T,fcol=1,fxlim=c(0,200),fylim=c(.25,.55))
# Add randoms to arbor types plot
plotOverLengths(randKmerFreqs[[1]],"C",minValues=10,plotXRange=T,yRangeType="SEM",new=F,fcol=1)
plotOverLengths(termGrowCFreqs,"C",minValues=10,plotXRange=T,yRangeType="SEM",new=F,fcol="gray40")
plotOverLengths(interstGrowCFreqs,"C",minValues=10,plotXRange=T,yRangeType="SEM",new=F,fcol="gray60")

legend(x=125,y=.35,legend=c("Axon","Apical","Dendrite","Uniform Randoms"),col=c(2,3,4,1),pch=1)
legend(x=100,y=.32,legend=c("Axon","Apical","Dendrite","Uniform Randoms","Term. Growth Randoms","Interst. Growth Randoms"),col=c(2,3,4,1,"gray40","gray60"),pch=1)
legend(x=200,y=.32,legend=c("Axon","Apical","Dendrite","Uniform Randoms","Term. Growth Randoms"),col=c(2,3,4,1,"gray40"),pch=1)

# Add in histogram plot
axonSeqLenHist <- hist(subset(metaData,ArborType=="Axon")$SeqLen,breaks=200,plot=F)
dendriteSeqLenHist <- hist(subset(metaData,ArborType=="Dendrite"|ArborType=="BasalDendrite")$SeqLen,breaks=200,plot=F)
apicalSeqLenHist <- hist(subset(metaData,ArborType=="ApicalDendrite")$SeqLen,breaks=200,plot=F)

histMod <- .05/max(axonSeqLenHist$density)
histMin <- .24
lines(axonSeqLenHist$mids,histMod*axonSeqLenHist$density+.24,col=2,add=T)

# Plot %C by dendrite cell types
dendTypes <- c("Pyramidal cell","Granule cell","Motoneuron","Medium spiny cell","Ganglion cell","Large aspiny cell","Interneuron")
mycolors <- c("black","red","green","blue","cyan","magenta","orange","brown")
plotOverLengths(dendriteCFreq,"C",minValues=10,plotXRange=F,yRangeType="None",title="Dendrite Type C Frequencies",new=T,col=mycolors[1],xlim=c(0,250),ylim=c(.25,.55))
for (ind in 1:length(dendTypes)){
  dendType <- dendTypes[ind]
  currTypeData <- getSubset(dendriteCFreq,cellType=dendType)
  plotOverLengths(currTypeData,"C",minValues=10,plotXRange=F,yRangeType="None",title="Dendrite Type C Frequencies",new=F,col=mycolors[ind+1],xlim=c(0,250),ylim=c(.25,.55))
}
legend(x=175,y=.355,legend=c("All types",dendTypes),col=mycolors,pch=1)

# Look at arbor type dimers
randAxonDimers<-getSubset(randKmerFreqs[[2]],arborType="Axon")
randApicalDimers<-getSubset(randKmerFreqs[[2]],arborType="ApicalDendrite")
randDendriteDimers<-getSubset(randKmerFreqs[[2]],arborType="Dendrite")

####################################################################
# Checking trimers of random sequences to see if there is a
#  discrepency between traversal order generation methods.

randLTS3mersSourceSTL <- getKmerFreqs(3,travOrder="LTS",sourceTraversal="STL",useRandomSets=40,useRandomK=2,method=8)
randLTS3mersSourceLTS <- getKmerFreqs(3,travOrder="LTS",sourceTraversal="LTS",useRandomSets=40,useRandomK=2,method=8)
randSTL3mersSourceSTL <- getKmerFreqs(3,travOrder="STL",sourceTraversal="STL",useRandomSets=40,useRandomK=2,method=8)
randSTL3mersSourceLTS <- getKmerFreqs(3,travOrder="STL",sourceTraversal="LTS",useRandomSets=40,useRandomK=2,method=8)

###################################################################
# Getting basic data about certain subsets
#
motoneuronDendC<-getSubset2(kmerFreqs[[1]],specifications=list(ExperCond="Control",ArborType="Dendrite",Class2="Motoneuron"),typeMetaData=masterMetaData)
motoneuronDendSeqs<-rownames(motoneuronDendC)
motoneuronDendSeqLens <- masterMetaData[motoneuronDendSeqs,"SeqLen"]
motoneuronData <- cbind(CFreq=motoneuronDendC,SeqLen=motoneuronDendSeqLens,CCount=round(motoneuronDendC$C*motoneuronDendSeqLens))

apicDendC<-getSubset2(kmerFreqs[[1]],specifications=list(ExperCond="Control",ArborType="ApicalDendrite",Class2="Pyramidal cell",BrainRegion=c("Hippocampus","Anterior Olfactory Nucleus")),typeMetaData=masterMetaData)
apicDendSeqs<-rownames(apicDendC)
apicDendSeqLens <- masterMetaData[apicDendSeqs,"SeqLen"]
apicDendData <- cbind(CFreq=apicDendC,SeqLen=apicDendSeqLens,CCount=round(apicDendC$C*apicDendSeqLens))