kmerFreqDirectory <- paste(motifDataDirectory,"/RawKmerFreqs/",sep="")
defaultOrder <- "STL"
defaultMethod <- 8
defaultThreshold <- "0.0"
defaultThreshType <- "Whole"

actualNumKmers <- c(1,9,25,68,183)

getKmerFreqs <- function(k,dataset='NM',travOrder=defaultOrder,method=defaultMethod,threshold=defaultThreshold,thresholdTypeString=defaultThreshType,directory=kmerFreqDirectory,useRandomSet=-1,useRandomSets=-1,useRandomK=k-1,sourceTraversal=travOrder){
  kmerFreqs <- read.csv(getKmerFreqsFilename(k,dataset,travOrder,method,threshold,thresholdTypeString,directory,useRandomSet,useRandomSets,useRandomK,sourceTraversal),stringsAsFactors=F,row.names=1)
  kmerFreqs <- subset(kmerFreqs,rownames(kmerFreqs)%in%rownames(masterMetaData))
  kmerFreqs
}

getKmerFreqsFilename <- function(k,dataset='NM',travOrder=defaultOrder,method=defaultMethod,threshold=defaultThreshold,thresholdTypeString=defaultThreshType,directory=kmerFreqDirectory,useRandomSet=-1,useRandomSets=-1,useRandomK=k-1,sourceTraversal=travOrder,oldVersion=F){
  if (useRandomSets > -1 && useRandomSet > -1){
    filename <- paste(directory,"KmerFreqs-Size",travOrder,"RandSets",useRandomSets,"MeanK",useRandomK,"-B",method,sourceTraversal,"_Set",useRandomSet,"-K",k,".csv",sep="")
  }
  else if (useRandomSets > -1){
    filename <- paste(directory,"KmerFreqs-Size",travOrder,"RandSets",useRandomSets,"MeanK",useRandomK,"-B",method,sourceTraversal,"-T",threshold,"-",thresholdTypeString,"-K",k,".csv",sep="")
  }
  else if (useRandomSet > -1){
    filename <- paste(directory,"KmerFreqs-Size",travOrder,"RandSet",useRandomSet,"K",useRandomK,"-B",method,sourceTraversal,"-T",threshold,"-",thresholdTypeString,"-K",k,".csv",sep="")
  }
  else{
    if (oldVersion){
      filename <- paste(directory,"typeDistsOf1-merFreqPure",k,"-Size",travOrder,"-Mapping2-Seqs.csv",sep="")
    }
    else{
      filename <- paste(directory,dataset,"-KmerFreqs-Size",travOrder,"-K",k,".csv",sep="")
    }
  }
  filename
}
