# StringUtils

generateKmers <- function(k,df=NULL){
  kmers <- c()
  for (i in 0:(3^k-1)){
    kmer <- ""
    num <- i
    for (j in 1:k){
      divisor <- 3^(k-j)
      currVal <- floor(num/divisor)
      char <- ACTDecode(currVal)
      kmer <- paste(kmer,char,sep="")
      num <- num - divisor * currVal
    }
    kmers <- c(kmers,kmer)
  }
  if (!is.null(df)){
    kmers <- kmers[kmers%in%colnames(df)]
  }
  kmers
}

getKmersForOutlierAnalysis <- function(k,df){
  kmers <- generateKmers(k,df)
  if (k > 2){
    pat <- "ATT"
    if (k > 3){
      for (i in 1:(k-3)){
        pat <- paste(".",pat,sep="")
      }
    }
    kmers <- kmers[-grep(pat,kmers)]
  }
  kmers
}

ACTDecode <- function(val){
  char <- ""
  if (val == 0){
    char <- "A"
  }
  else if (val == 1){
    char <- "C"
  }
  else if (val == 2){
    char <- "T"
  }
  char
}
